"""autogenerated by genpy from object_manipulation_msgs/PickupResult.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import std_msgs.msg
import object_manipulation_msgs.msg
import household_objects_database_msgs.msg
import sensor_msgs.msg

class PickupResult(genpy.Message):
  _md5sum = "e37faa4bc17adb31e87f0a21276cde44"
  _type = "object_manipulation_msgs/PickupResult"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# The overall result of the pickup attempt
ManipulationResult manipulation_result

# The performed grasp, if attempt was successful
Grasp grasp

# the complete list of attempted grasp, in the order in which they have been attempted
# the successful one should be the last one in this list
Grasp[] attempted_grasps

# the outcomes of the attempted grasps, in the same order as attempted_grasps
GraspResult[] attempted_grasp_results


================================================================================
MSG: object_manipulation_msgs/ManipulationResult
# Result codes for manipulation tasks

# task completed as expected
# generally means you can proceed as planned
int32 SUCCESS = 1

# task not possible (e.g. out of reach or obstacles in the way)
# generally means that the world was not disturbed, so you can try another task
int32 UNFEASIBLE = -1

# task was thought possible, but failed due to unexpected events during execution
# it is likely that the world was disturbed, so you are encouraged to refresh
# your sensed world model before proceeding to another task
int32 FAILED = -2

# a lower level error prevented task completion (e.g. joint controller not responding)
# generally requires human attention
int32 ERROR = -3

# means that at some point during execution we ended up in a state that the collision-aware
# arm navigation module will not move out of. The world was likely not disturbed, but you 
# probably need a new collision map to move the arm out of the stuck position
int32 ARM_MOVEMENT_PREVENTED = -4

# specific to grasp actions
# the object was grasped successfully, but the lift attempt could not achieve the minimum lift distance requested
# it is likely that the collision environment will see collisions between the hand/object and the support surface
int32 LIFT_FAILED = -5

# specific to place actions
# the object was placed successfully, but the retreat attempt could not achieve the minimum retreat distance requested
# it is likely that the collision environment will see collisions between the hand and the object
int32 RETREAT_FAILED = -6

# indicates that somewhere along the line a human said "wait, stop, this is bad, go back and do something else"
int32 CANCELLED = -7

# the actual value of this error code
int32 value

================================================================================
MSG: object_manipulation_msgs/Grasp

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/Pose grasp_pose

# The estimated probability of success for this grasp
float64 success_probability

# Debug flag to indicate that this grasp would be the best in its cluster
bool cluster_rep

# how far the pre-grasp should ideally be away from the grasp
float32 desired_approach_distance

# how much distance between pre-grasp and grasp must actually be feasible 
# for the grasp not to be rejected
float32 min_approach_distance

# an optional list of obstacles that we have semantic information about
# and that we expect might move in the course of executing this grasp
# the grasp planner is expected to make sure they move in an OK way; during
# execution, grasp executors will not check for collisions against these objects
GraspableObject[] moved_obstacles

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: object_manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# a graspable object can be represented in multiple ways. This message
# can contain all of them. Which one is actually used is up to the receiver
# of this message. When adding new representations, one must be careful that
# they have reasonable lightweight defaults indicating that that particular
# representation is not available.

# the tf frame to be used as a reference frame when combining information from
# the different representations below
string reference_frame_id

# potential recognition results from a database of models
# all poses are relative to the object reference pose
household_objects_database_msgs/DatabaseModelPose[] potential_models

# the point cloud itself
sensor_msgs/PointCloud cluster

# a region of a PointCloud2 of interest
object_manipulation_msgs/SceneRegion region

# the name that this object has in the collision environment
string collision_name
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: sensor_msgs/PointCloud
# This message holds a collection of 3d points, plus optional additional
# information about each point.

# Time of sensor data acquisition, coordinate frame ID.
Header header

# Array of 3d points. Each Point32 should be interpreted as a 3d point
# in the frame given in the header.
geometry_msgs/Point32[] points

# Each channel should have the same number of elements as points array,
# and the data in each channel should correspond 1:1 with each point.
# Channel names in common practice are listed in ChannelFloat32.msg.
ChannelFloat32[] channels

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   "u", "v" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   "rgb" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   "intensity" - laser or pixel intensity.
#   "distance"

# The channel name should give semantics of the channel (e.g.
# "intensity" instead of "value").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: object_manipulation_msgs/SceneRegion
# Point cloud
sensor_msgs/PointCloud2 cloud

# Indices for the region of interest
int32[] mask

# One of the corresponding 2D images, if applicable
sensor_msgs/Image image

# The disparity image, if applicable
sensor_msgs/Image disparity_image

# Camera info for the camera that took the image
sensor_msgs/CameraInfo cam_info

# a 3D region of interest for grasp planning
geometry_msgs/PoseStamped  roi_box_pose
geometry_msgs/Vector3 	   roi_box_dims

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic "camera_info" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may "recalibrate" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, "plumb_bob" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For "plumb_bob", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger "super-pixels." It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the "raw"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: object_manipulation_msgs/GraspResult
int32 SUCCESS = 1
int32 GRASP_OUT_OF_REACH = 2
int32 GRASP_IN_COLLISION = 3
int32 GRASP_UNFEASIBLE = 4
int32 PREGRASP_OUT_OF_REACH = 5
int32 PREGRASP_IN_COLLISION = 6
int32 PREGRASP_UNFEASIBLE = 7
int32 LIFT_OUT_OF_REACH = 8
int32 LIFT_IN_COLLISION = 9
int32 LIFT_UNFEASIBLE = 10
int32 MOVE_ARM_FAILED = 11
int32 GRASP_FAILED = 12
int32 LIFT_FAILED = 13
int32 RETREAT_FAILED = 14
int32 result_code

# whether the state of the world was disturbed by this attempt. generally, this flag
# shows if another task can be attempted, or a new sensed world model is recommeded
# before proceeding
bool continuation_possible

"""
  __slots__ = ['manipulation_result','grasp','attempted_grasps','attempted_grasp_results']
  _slot_types = ['object_manipulation_msgs/ManipulationResult','object_manipulation_msgs/Grasp','object_manipulation_msgs/Grasp[]','object_manipulation_msgs/GraspResult[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       manipulation_result,grasp,attempted_grasps,attempted_grasp_results

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PickupResult, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.manipulation_result is None:
        self.manipulation_result = object_manipulation_msgs.msg.ManipulationResult()
      if self.grasp is None:
        self.grasp = object_manipulation_msgs.msg.Grasp()
      if self.attempted_grasps is None:
        self.attempted_grasps = []
      if self.attempted_grasp_results is None:
        self.attempted_grasp_results = []
    else:
      self.manipulation_result = object_manipulation_msgs.msg.ManipulationResult()
      self.grasp = object_manipulation_msgs.msg.Grasp()
      self.attempted_grasps = []
      self.attempted_grasp_results = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_i3I.pack(_x.manipulation_result.value, _x.grasp.pre_grasp_posture.header.seq, _x.grasp.pre_grasp_posture.header.stamp.secs, _x.grasp.pre_grasp_posture.header.stamp.nsecs))
      _x = self.grasp.pre_grasp_posture.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasp.pre_grasp_posture.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.pre_grasp_posture.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.grasp.pre_grasp_posture.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.pre_grasp_posture.position))
      length = len(self.grasp.pre_grasp_posture.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.pre_grasp_posture.velocity))
      length = len(self.grasp.pre_grasp_posture.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.pre_grasp_posture.effort))
      _x = self
      buff.write(_struct_3I.pack(_x.grasp.grasp_posture.header.seq, _x.grasp.grasp_posture.header.stamp.secs, _x.grasp.grasp_posture.header.stamp.nsecs))
      _x = self.grasp.grasp_posture.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasp.grasp_posture.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.grasp_posture.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.grasp.grasp_posture.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.grasp_posture.position))
      length = len(self.grasp.grasp_posture.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.grasp_posture.velocity))
      length = len(self.grasp.grasp_posture.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.grasp.grasp_posture.effort))
      _x = self
      buff.write(_struct_8dB2f.pack(_x.grasp.grasp_pose.position.x, _x.grasp.grasp_pose.position.y, _x.grasp.grasp_pose.position.z, _x.grasp.grasp_pose.orientation.x, _x.grasp.grasp_pose.orientation.y, _x.grasp.grasp_pose.orientation.z, _x.grasp.grasp_pose.orientation.w, _x.grasp.success_probability, _x.grasp.cluster_rep, _x.grasp.desired_approach_distance, _x.grasp.min_approach_distance))
      length = len(self.grasp.moved_obstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.moved_obstacles:
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.potential_models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.potential_models:
          buff.write(_struct_i.pack(val2.model_id))
          _v1 = val2.pose
          _v2 = _v1.header
          buff.write(_struct_I.pack(_v2.seq))
          _v3 = _v2.stamp
          _x = _v3
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v2.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v4 = _v1.pose
          _v5 = _v4.position
          _x = _v5
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v6 = _v4.orientation
          _x = _v6
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v7 = val1.cluster
        _v8 = _v7.header
        buff.write(_struct_I.pack(_v8.seq))
        _v9 = _v8.stamp
        _x = _v9
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v8.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v7.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v7.points:
          _x = val3
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        length = len(_v7.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v7.channels:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val3.values))
        _v10 = val1.region
        _v11 = _v10.cloud
        _v12 = _v11.header
        buff.write(_struct_I.pack(_v12.seq))
        _v13 = _v12.stamp
        _x = _v13
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v12.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v11
        buff.write(_struct_2I.pack(_x.height, _x.width))
        length = len(_v11.fields)
        buff.write(_struct_I.pack(length))
        for val4 in _v11.fields:
          _x = val4.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val4
          buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
        _x = _v11
        buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v11.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(_v11.is_dense))
        length = len(_v10.mask)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *_v10.mask))
        _v14 = _v10.image
        _v15 = _v14.header
        buff.write(_struct_I.pack(_v15.seq))
        _v16 = _v15.stamp
        _x = _v16
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v15.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v14
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v14.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v14
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v14.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v17 = _v10.disparity_image
        _v18 = _v17.header
        buff.write(_struct_I.pack(_v18.seq))
        _v19 = _v18.stamp
        _x = _v19
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v18.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v17
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v17.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v17
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v17.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v20 = _v10.cam_info
        _v21 = _v20.header
        buff.write(_struct_I.pack(_v21.seq))
        _v22 = _v21.stamp
        _x = _v22
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v21.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v20
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v20.distortion_model
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v20.D)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v20.D))
        buff.write(_struct_9d.pack(*_v20.K))
        buff.write(_struct_9d.pack(*_v20.R))
        buff.write(_struct_12d.pack(*_v20.P))
        _x = _v20
        buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
        _v23 = _v20.roi
        _x = _v23
        buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v24 = _v10.roi_box_pose
        _v25 = _v24.header
        buff.write(_struct_I.pack(_v25.seq))
        _v26 = _v25.stamp
        _x = _v26
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v25.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v27 = _v24.pose
        _v28 = _v27.position
        _x = _v28
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v29 = _v27.orientation
        _x = _v29
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v30 = _v10.roi_box_dims
        _x = _v30
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.attempted_grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.attempted_grasps:
        _v31 = val1.pre_grasp_posture
        _v32 = _v31.header
        buff.write(_struct_I.pack(_v32.seq))
        _v33 = _v32.stamp
        _x = _v33
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v32.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v31.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v31.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v31.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v31.position))
        length = len(_v31.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v31.velocity))
        length = len(_v31.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v31.effort))
        _v34 = val1.grasp_posture
        _v35 = _v34.header
        buff.write(_struct_I.pack(_v35.seq))
        _v36 = _v35.stamp
        _x = _v36
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v35.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v34.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v34.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v34.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v34.position))
        length = len(_v34.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v34.velocity))
        length = len(_v34.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v34.effort))
        _v37 = val1.grasp_pose
        _v38 = _v37.position
        _x = _v38
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v39 = _v37.orientation
        _x = _v39
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v40 = val3.pose
            _v41 = _v40.header
            buff.write(_struct_I.pack(_v41.seq))
            _v42 = _v41.stamp
            _x = _v42
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v41.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v43 = _v40.pose
            _v44 = _v43.position
            _x = _v44
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v45 = _v43.orientation
            _x = _v45
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v46 = val2.cluster
          _v47 = _v46.header
          buff.write(_struct_I.pack(_v47.seq))
          _v48 = _v47.stamp
          _x = _v48
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v47.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v46.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v46.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v46.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v46.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(struct.pack(pattern, *val4.values))
          _v49 = val2.region
          _v50 = _v49.cloud
          _v51 = _v50.header
          buff.write(_struct_I.pack(_v51.seq))
          _v52 = _v51.stamp
          _x = _v52
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v51.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v50
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v50.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v50.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v50
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v50.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v50.is_dense))
          length = len(_v49.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(struct.pack(pattern, *_v49.mask))
          _v53 = _v49.image
          _v54 = _v53.header
          buff.write(_struct_I.pack(_v54.seq))
          _v55 = _v54.stamp
          _x = _v55
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v54.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v53
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v53.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v53
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v53.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v56 = _v49.disparity_image
          _v57 = _v56.header
          buff.write(_struct_I.pack(_v57.seq))
          _v58 = _v57.stamp
          _x = _v58
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v57.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v56
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v56.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v56
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v56.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v59 = _v49.cam_info
          _v60 = _v59.header
          buff.write(_struct_I.pack(_v60.seq))
          _v61 = _v60.stamp
          _x = _v61
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v60.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v59
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v59.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v59.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *_v59.D))
          buff.write(_struct_9d.pack(*_v59.K))
          buff.write(_struct_9d.pack(*_v59.R))
          buff.write(_struct_12d.pack(*_v59.P))
          _x = _v59
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v62 = _v59.roi
          _x = _v62
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v63 = _v49.roi_box_pose
          _v64 = _v63.header
          buff.write(_struct_I.pack(_v64.seq))
          _v65 = _v64.stamp
          _x = _v65
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v64.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v66 = _v63.pose
          _v67 = _v66.position
          _x = _v67
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v68 = _v66.orientation
          _x = _v68
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v69 = _v49.roi_box_dims
          _x = _v69
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.attempted_grasp_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.attempted_grasp_results:
        _x = val1
        buff.write(_struct_iB.pack(_x.result_code, _x.continuation_possible))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.manipulation_result is None:
        self.manipulation_result = object_manipulation_msgs.msg.ManipulationResult()
      if self.grasp is None:
        self.grasp = object_manipulation_msgs.msg.Grasp()
      if self.attempted_grasps is None:
        self.attempted_grasps = None
      if self.attempted_grasp_results is None:
        self.attempted_grasp_results = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.manipulation_result.value, _x.grasp.pre_grasp_posture.header.seq, _x.grasp.pre_grasp_posture.header.stamp.secs, _x.grasp.pre_grasp_posture.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.grasp.pre_grasp_posture.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.grasp.pre_grasp_posture.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.pre_grasp_posture.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.grasp.pre_grasp_posture.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.effort = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.grasp.grasp_posture.header.seq, _x.grasp.grasp_posture.header.stamp.secs, _x.grasp.grasp_posture.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.grasp.grasp_posture.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.grasp.grasp_posture.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.grasp_posture.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.grasp.grasp_posture.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.position = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.velocity = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.effort = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 73
      (_x.grasp.grasp_pose.position.x, _x.grasp.grasp_pose.position.y, _x.grasp.grasp_pose.position.z, _x.grasp.grasp_pose.orientation.x, _x.grasp.grasp_pose.orientation.y, _x.grasp.grasp_pose.orientation.z, _x.grasp.grasp_pose.orientation.w, _x.grasp.success_probability, _x.grasp.cluster_rep, _x.grasp.desired_approach_distance, _x.grasp.min_approach_distance,) = _struct_8dB2f.unpack(str[start:end])
      self.grasp.cluster_rep = bool(self.grasp.cluster_rep)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.moved_obstacles = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspableObject()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.potential_models = []
        for i in range(0, length):
          val2 = household_objects_database_msgs.msg.DatabaseModelPose()
          start = end
          end += 4
          (val2.model_id,) = _struct_i.unpack(str[start:end])
          _v70 = val2.pose
          _v71 = _v70.header
          start = end
          end += 4
          (_v71.seq,) = _struct_I.unpack(str[start:end])
          _v72 = _v71.stamp
          _x = _v72
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v71.frame_id = str[start:end].decode('utf-8')
          else:
            _v71.frame_id = str[start:end]
          _v73 = _v70.pose
          _v74 = _v73.position
          _x = _v74
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v75 = _v73.orientation
          _x = _v75
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.confidence,) = _struct_f.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detector_name = str[start:end].decode('utf-8')
          else:
            val2.detector_name = str[start:end]
          val1.potential_models.append(val2)
        _v76 = val1.cluster
        _v77 = _v76.header
        start = end
        end += 4
        (_v77.seq,) = _struct_I.unpack(str[start:end])
        _v78 = _v77.stamp
        _x = _v78
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v77.frame_id = str[start:end].decode('utf-8')
        else:
          _v77.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v76.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v76.points.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v76.channels = []
        for i in range(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = struct.unpack(pattern, str[start:end])
          _v76.channels.append(val3)
        _v79 = val1.region
        _v80 = _v79.cloud
        _v81 = _v80.header
        start = end
        end += 4
        (_v81.seq,) = _struct_I.unpack(str[start:end])
        _v82 = _v81.stamp
        _x = _v82
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v81.frame_id = str[start:end].decode('utf-8')
        else:
          _v81.frame_id = str[start:end]
        _x = _v80
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v80.fields = []
        for i in range(0, length):
          val4 = sensor_msgs.msg.PointField()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.name = str[start:end].decode('utf-8')
          else:
            val4.name = str[start:end]
          _x = val4
          start = end
          end += 9
          (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
          _v80.fields.append(val4)
        _x = _v80
        start = end
        end += 9
        (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
        _v80.is_bigendian = bool(_v80.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v80.data = str[start:end].decode('utf-8')
        else:
          _v80.data = str[start:end]
        start = end
        end += 1
        (_v80.is_dense,) = _struct_B.unpack(str[start:end])
        _v80.is_dense = bool(_v80.is_dense)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v79.mask = struct.unpack(pattern, str[start:end])
        _v83 = _v79.image
        _v84 = _v83.header
        start = end
        end += 4
        (_v84.seq,) = _struct_I.unpack(str[start:end])
        _v85 = _v84.stamp
        _x = _v85
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v84.frame_id = str[start:end].decode('utf-8')
        else:
          _v84.frame_id = str[start:end]
        _x = _v83
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v83.encoding = str[start:end].decode('utf-8')
        else:
          _v83.encoding = str[start:end]
        _x = _v83
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v83.data = str[start:end].decode('utf-8')
        else:
          _v83.data = str[start:end]
        _v86 = _v79.disparity_image
        _v87 = _v86.header
        start = end
        end += 4
        (_v87.seq,) = _struct_I.unpack(str[start:end])
        _v88 = _v87.stamp
        _x = _v88
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v87.frame_id = str[start:end].decode('utf-8')
        else:
          _v87.frame_id = str[start:end]
        _x = _v86
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v86.encoding = str[start:end].decode('utf-8')
        else:
          _v86.encoding = str[start:end]
        _x = _v86
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v86.data = str[start:end].decode('utf-8')
        else:
          _v86.data = str[start:end]
        _v89 = _v79.cam_info
        _v90 = _v89.header
        start = end
        end += 4
        (_v90.seq,) = _struct_I.unpack(str[start:end])
        _v91 = _v90.stamp
        _x = _v91
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v90.frame_id = str[start:end].decode('utf-8')
        else:
          _v90.frame_id = str[start:end]
        _x = _v89
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v89.distortion_model = str[start:end].decode('utf-8')
        else:
          _v89.distortion_model = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v89.D = struct.unpack(pattern, str[start:end])
        start = end
        end += 72
        _v89.K = _struct_9d.unpack(str[start:end])
        start = end
        end += 72
        _v89.R = _struct_9d.unpack(str[start:end])
        start = end
        end += 96
        _v89.P = _struct_12d.unpack(str[start:end])
        _x = _v89
        start = end
        end += 8
        (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
        _v92 = _v89.roi
        _x = _v92
        start = end
        end += 17
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
        _v92.do_rectify = bool(_v92.do_rectify)
        _v93 = _v79.roi_box_pose
        _v94 = _v93.header
        start = end
        end += 4
        (_v94.seq,) = _struct_I.unpack(str[start:end])
        _v95 = _v94.stamp
        _x = _v95
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v94.frame_id = str[start:end].decode('utf-8')
        else:
          _v94.frame_id = str[start:end]
        _v96 = _v93.pose
        _v97 = _v96.position
        _x = _v97
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v98 = _v96.orientation
        _x = _v98
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v99 = _v79.roi_box_dims
        _x = _v99
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.collision_name = str[start:end].decode('utf-8')
        else:
          val1.collision_name = str[start:end]
        self.grasp.moved_obstacles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attempted_grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v100 = val1.pre_grasp_posture
        _v101 = _v100.header
        start = end
        end += 4
        (_v101.seq,) = _struct_I.unpack(str[start:end])
        _v102 = _v101.stamp
        _x = _v102
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v101.frame_id = str[start:end].decode('utf-8')
        else:
          _v101.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v100.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v100.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v100.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v100.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v100.effort = struct.unpack(pattern, str[start:end])
        _v103 = val1.grasp_posture
        _v104 = _v103.header
        start = end
        end += 4
        (_v104.seq,) = _struct_I.unpack(str[start:end])
        _v105 = _v104.stamp
        _x = _v105
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v104.frame_id = str[start:end].decode('utf-8')
        else:
          _v104.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v103.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v103.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v103.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v103.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v103.effort = struct.unpack(pattern, str[start:end])
        _v106 = val1.grasp_pose
        _v107 = _v106.position
        _x = _v107
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v108 = _v106.orientation
        _x = _v108
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v109 = val3.pose
            _v110 = _v109.header
            start = end
            end += 4
            (_v110.seq,) = _struct_I.unpack(str[start:end])
            _v111 = _v110.stamp
            _x = _v111
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v110.frame_id = str[start:end].decode('utf-8')
            else:
              _v110.frame_id = str[start:end]
            _v112 = _v109.pose
            _v113 = _v112.position
            _x = _v113
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v114 = _v112.orientation
            _x = _v114
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v115 = val2.cluster
          _v116 = _v115.header
          start = end
          end += 4
          (_v116.seq,) = _struct_I.unpack(str[start:end])
          _v117 = _v116.stamp
          _x = _v117
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v116.frame_id = str[start:end].decode('utf-8')
          else:
            _v116.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v115.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v115.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v115.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = struct.unpack(pattern, str[start:end])
            _v115.channels.append(val4)
          _v118 = val2.region
          _v119 = _v118.cloud
          _v120 = _v119.header
          start = end
          end += 4
          (_v120.seq,) = _struct_I.unpack(str[start:end])
          _v121 = _v120.stamp
          _x = _v121
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v120.frame_id = str[start:end].decode('utf-8')
          else:
            _v120.frame_id = str[start:end]
          _x = _v119
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v119.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v119.fields.append(val5)
          _x = _v119
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v119.is_bigendian = bool(_v119.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v119.data = str[start:end].decode('utf-8')
          else:
            _v119.data = str[start:end]
          start = end
          end += 1
          (_v119.is_dense,) = _struct_B.unpack(str[start:end])
          _v119.is_dense = bool(_v119.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v118.mask = struct.unpack(pattern, str[start:end])
          _v122 = _v118.image
          _v123 = _v122.header
          start = end
          end += 4
          (_v123.seq,) = _struct_I.unpack(str[start:end])
          _v124 = _v123.stamp
          _x = _v124
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v123.frame_id = str[start:end].decode('utf-8')
          else:
            _v123.frame_id = str[start:end]
          _x = _v122
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v122.encoding = str[start:end].decode('utf-8')
          else:
            _v122.encoding = str[start:end]
          _x = _v122
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v122.data = str[start:end].decode('utf-8')
          else:
            _v122.data = str[start:end]
          _v125 = _v118.disparity_image
          _v126 = _v125.header
          start = end
          end += 4
          (_v126.seq,) = _struct_I.unpack(str[start:end])
          _v127 = _v126.stamp
          _x = _v127
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v126.frame_id = str[start:end].decode('utf-8')
          else:
            _v126.frame_id = str[start:end]
          _x = _v125
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v125.encoding = str[start:end].decode('utf-8')
          else:
            _v125.encoding = str[start:end]
          _x = _v125
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v125.data = str[start:end].decode('utf-8')
          else:
            _v125.data = str[start:end]
          _v128 = _v118.cam_info
          _v129 = _v128.header
          start = end
          end += 4
          (_v129.seq,) = _struct_I.unpack(str[start:end])
          _v130 = _v129.stamp
          _x = _v130
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v129.frame_id = str[start:end].decode('utf-8')
          else:
            _v129.frame_id = str[start:end]
          _x = _v128
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v128.distortion_model = str[start:end].decode('utf-8')
          else:
            _v128.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v128.D = struct.unpack(pattern, str[start:end])
          start = end
          end += 72
          _v128.K = _struct_9d.unpack(str[start:end])
          start = end
          end += 72
          _v128.R = _struct_9d.unpack(str[start:end])
          start = end
          end += 96
          _v128.P = _struct_12d.unpack(str[start:end])
          _x = _v128
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v131 = _v128.roi
          _x = _v131
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v131.do_rectify = bool(_v131.do_rectify)
          _v132 = _v118.roi_box_pose
          _v133 = _v132.header
          start = end
          end += 4
          (_v133.seq,) = _struct_I.unpack(str[start:end])
          _v134 = _v133.stamp
          _x = _v134
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v133.frame_id = str[start:end].decode('utf-8')
          else:
            _v133.frame_id = str[start:end]
          _v135 = _v132.pose
          _v136 = _v135.position
          _x = _v136
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v137 = _v135.orientation
          _x = _v137
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v138 = _v118.roi_box_dims
          _x = _v138
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.attempted_grasps.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attempted_grasp_results = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspResult()
        _x = val1
        start = end
        end += 5
        (_x.result_code, _x.continuation_possible,) = _struct_iB.unpack(str[start:end])
        val1.continuation_possible = bool(val1.continuation_possible)
        self.attempted_grasp_results.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_i3I.pack(_x.manipulation_result.value, _x.grasp.pre_grasp_posture.header.seq, _x.grasp.pre_grasp_posture.header.stamp.secs, _x.grasp.pre_grasp_posture.header.stamp.nsecs))
      _x = self.grasp.pre_grasp_posture.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasp.pre_grasp_posture.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.pre_grasp_posture.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.grasp.pre_grasp_posture.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.pre_grasp_posture.position.tostring())
      length = len(self.grasp.pre_grasp_posture.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.pre_grasp_posture.velocity.tostring())
      length = len(self.grasp.pre_grasp_posture.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.pre_grasp_posture.effort.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.grasp.grasp_posture.header.seq, _x.grasp.grasp_posture.header.stamp.secs, _x.grasp.grasp_posture.header.stamp.nsecs))
      _x = self.grasp.grasp_posture.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasp.grasp_posture.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.grasp_posture.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.pack('<I%ss'%length, length, val1))
      length = len(self.grasp.grasp_posture.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.grasp_posture.position.tostring())
      length = len(self.grasp.grasp_posture.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.grasp_posture.velocity.tostring())
      length = len(self.grasp.grasp_posture.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.grasp.grasp_posture.effort.tostring())
      _x = self
      buff.write(_struct_8dB2f.pack(_x.grasp.grasp_pose.position.x, _x.grasp.grasp_pose.position.y, _x.grasp.grasp_pose.position.z, _x.grasp.grasp_pose.orientation.x, _x.grasp.grasp_pose.orientation.y, _x.grasp.grasp_pose.orientation.z, _x.grasp.grasp_pose.orientation.w, _x.grasp.success_probability, _x.grasp.cluster_rep, _x.grasp.desired_approach_distance, _x.grasp.min_approach_distance))
      length = len(self.grasp.moved_obstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasp.moved_obstacles:
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.potential_models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.potential_models:
          buff.write(_struct_i.pack(val2.model_id))
          _v139 = val2.pose
          _v140 = _v139.header
          buff.write(_struct_I.pack(_v140.seq))
          _v141 = _v140.stamp
          _x = _v141
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v140.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v142 = _v139.pose
          _v143 = _v142.position
          _x = _v143
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v144 = _v142.orientation
          _x = _v144
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v145 = val1.cluster
        _v146 = _v145.header
        buff.write(_struct_I.pack(_v146.seq))
        _v147 = _v146.stamp
        _x = _v147
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v146.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v145.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v145.points:
          _x = val3
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        length = len(_v145.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v145.channels:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val3.values.tostring())
        _v148 = val1.region
        _v149 = _v148.cloud
        _v150 = _v149.header
        buff.write(_struct_I.pack(_v150.seq))
        _v151 = _v150.stamp
        _x = _v151
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v150.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v149
        buff.write(_struct_2I.pack(_x.height, _x.width))
        length = len(_v149.fields)
        buff.write(_struct_I.pack(length))
        for val4 in _v149.fields:
          _x = val4.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val4
          buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
        _x = _v149
        buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v149.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(_v149.is_dense))
        length = len(_v148.mask)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(_v148.mask.tostring())
        _v152 = _v148.image
        _v153 = _v152.header
        buff.write(_struct_I.pack(_v153.seq))
        _v154 = _v153.stamp
        _x = _v154
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v153.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v152
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v152.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v152
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v152.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v155 = _v148.disparity_image
        _v156 = _v155.header
        buff.write(_struct_I.pack(_v156.seq))
        _v157 = _v156.stamp
        _x = _v157
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v156.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v155
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v155.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v155
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v155.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v158 = _v148.cam_info
        _v159 = _v158.header
        buff.write(_struct_I.pack(_v159.seq))
        _v160 = _v159.stamp
        _x = _v160
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v159.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v158
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v158.distortion_model
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v158.D)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v158.D.tostring())
        buff.write(_v158.K.tostring())
        buff.write(_v158.R.tostring())
        buff.write(_v158.P.tostring())
        _x = _v158
        buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
        _v161 = _v158.roi
        _x = _v161
        buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v162 = _v148.roi_box_pose
        _v163 = _v162.header
        buff.write(_struct_I.pack(_v163.seq))
        _v164 = _v163.stamp
        _x = _v164
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v163.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v165 = _v162.pose
        _v166 = _v165.position
        _x = _v166
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v167 = _v165.orientation
        _x = _v167
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v168 = _v148.roi_box_dims
        _x = _v168
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.attempted_grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.attempted_grasps:
        _v169 = val1.pre_grasp_posture
        _v170 = _v169.header
        buff.write(_struct_I.pack(_v170.seq))
        _v171 = _v170.stamp
        _x = _v171
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v170.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v169.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v169.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v169.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v169.position.tostring())
        length = len(_v169.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v169.velocity.tostring())
        length = len(_v169.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v169.effort.tostring())
        _v172 = val1.grasp_posture
        _v173 = _v172.header
        buff.write(_struct_I.pack(_v173.seq))
        _v174 = _v173.stamp
        _x = _v174
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v173.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v172.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v172.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v172.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v172.position.tostring())
        length = len(_v172.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v172.velocity.tostring())
        length = len(_v172.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v172.effort.tostring())
        _v175 = val1.grasp_pose
        _v176 = _v175.position
        _x = _v176
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v177 = _v175.orientation
        _x = _v177
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v178 = val3.pose
            _v179 = _v178.header
            buff.write(_struct_I.pack(_v179.seq))
            _v180 = _v179.stamp
            _x = _v180
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v179.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v181 = _v178.pose
            _v182 = _v181.position
            _x = _v182
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v183 = _v181.orientation
            _x = _v183
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v184 = val2.cluster
          _v185 = _v184.header
          buff.write(_struct_I.pack(_v185.seq))
          _v186 = _v185.stamp
          _x = _v186
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v185.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v184.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v184.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v184.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v184.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(val4.values.tostring())
          _v187 = val2.region
          _v188 = _v187.cloud
          _v189 = _v188.header
          buff.write(_struct_I.pack(_v189.seq))
          _v190 = _v189.stamp
          _x = _v190
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v189.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v188
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v188.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v188.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v188
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v188.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v188.is_dense))
          length = len(_v187.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(_v187.mask.tostring())
          _v191 = _v187.image
          _v192 = _v191.header
          buff.write(_struct_I.pack(_v192.seq))
          _v193 = _v192.stamp
          _x = _v193
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v192.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v191
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v191.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v191
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v191.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v194 = _v187.disparity_image
          _v195 = _v194.header
          buff.write(_struct_I.pack(_v195.seq))
          _v196 = _v195.stamp
          _x = _v196
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v195.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v194
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v194.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v194
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v194.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v197 = _v187.cam_info
          _v198 = _v197.header
          buff.write(_struct_I.pack(_v198.seq))
          _v199 = _v198.stamp
          _x = _v199
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v198.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v197
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v197.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v197.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(_v197.D.tostring())
          buff.write(_v197.K.tostring())
          buff.write(_v197.R.tostring())
          buff.write(_v197.P.tostring())
          _x = _v197
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v200 = _v197.roi
          _x = _v200
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v201 = _v187.roi_box_pose
          _v202 = _v201.header
          buff.write(_struct_I.pack(_v202.seq))
          _v203 = _v202.stamp
          _x = _v203
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v202.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v204 = _v201.pose
          _v205 = _v204.position
          _x = _v205
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v206 = _v204.orientation
          _x = _v206
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v207 = _v187.roi_box_dims
          _x = _v207
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.attempted_grasp_results)
      buff.write(_struct_I.pack(length))
      for val1 in self.attempted_grasp_results:
        _x = val1
        buff.write(_struct_iB.pack(_x.result_code, _x.continuation_possible))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.manipulation_result is None:
        self.manipulation_result = object_manipulation_msgs.msg.ManipulationResult()
      if self.grasp is None:
        self.grasp = object_manipulation_msgs.msg.Grasp()
      if self.attempted_grasps is None:
        self.attempted_grasps = None
      if self.attempted_grasp_results is None:
        self.attempted_grasp_results = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.manipulation_result.value, _x.grasp.pre_grasp_posture.header.seq, _x.grasp.pre_grasp_posture.header.stamp.secs, _x.grasp.pre_grasp_posture.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.grasp.pre_grasp_posture.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.grasp.pre_grasp_posture.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.pre_grasp_posture.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.grasp.pre_grasp_posture.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.pre_grasp_posture.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.grasp.grasp_posture.header.seq, _x.grasp.grasp_posture.header.stamp.secs, _x.grasp.grasp_posture.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.grasp.grasp_posture.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.grasp.grasp_posture.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.grasp_posture.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8')
        else:
          val1 = str[start:end]
        self.grasp.grasp_posture.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.grasp.grasp_posture.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 73
      (_x.grasp.grasp_pose.position.x, _x.grasp.grasp_pose.position.y, _x.grasp.grasp_pose.position.z, _x.grasp.grasp_pose.orientation.x, _x.grasp.grasp_pose.orientation.y, _x.grasp.grasp_pose.orientation.z, _x.grasp.grasp_pose.orientation.w, _x.grasp.success_probability, _x.grasp.cluster_rep, _x.grasp.desired_approach_distance, _x.grasp.min_approach_distance,) = _struct_8dB2f.unpack(str[start:end])
      self.grasp.cluster_rep = bool(self.grasp.cluster_rep)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasp.moved_obstacles = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspableObject()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.potential_models = []
        for i in range(0, length):
          val2 = household_objects_database_msgs.msg.DatabaseModelPose()
          start = end
          end += 4
          (val2.model_id,) = _struct_i.unpack(str[start:end])
          _v208 = val2.pose
          _v209 = _v208.header
          start = end
          end += 4
          (_v209.seq,) = _struct_I.unpack(str[start:end])
          _v210 = _v209.stamp
          _x = _v210
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v209.frame_id = str[start:end].decode('utf-8')
          else:
            _v209.frame_id = str[start:end]
          _v211 = _v208.pose
          _v212 = _v211.position
          _x = _v212
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v213 = _v211.orientation
          _x = _v213
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.confidence,) = _struct_f.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detector_name = str[start:end].decode('utf-8')
          else:
            val2.detector_name = str[start:end]
          val1.potential_models.append(val2)
        _v214 = val1.cluster
        _v215 = _v214.header
        start = end
        end += 4
        (_v215.seq,) = _struct_I.unpack(str[start:end])
        _v216 = _v215.stamp
        _x = _v216
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v215.frame_id = str[start:end].decode('utf-8')
        else:
          _v215.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v214.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v214.points.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v214.channels = []
        for i in range(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          _v214.channels.append(val3)
        _v217 = val1.region
        _v218 = _v217.cloud
        _v219 = _v218.header
        start = end
        end += 4
        (_v219.seq,) = _struct_I.unpack(str[start:end])
        _v220 = _v219.stamp
        _x = _v220
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v219.frame_id = str[start:end].decode('utf-8')
        else:
          _v219.frame_id = str[start:end]
        _x = _v218
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v218.fields = []
        for i in range(0, length):
          val4 = sensor_msgs.msg.PointField()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.name = str[start:end].decode('utf-8')
          else:
            val4.name = str[start:end]
          _x = val4
          start = end
          end += 9
          (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
          _v218.fields.append(val4)
        _x = _v218
        start = end
        end += 9
        (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
        _v218.is_bigendian = bool(_v218.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v218.data = str[start:end].decode('utf-8')
        else:
          _v218.data = str[start:end]
        start = end
        end += 1
        (_v218.is_dense,) = _struct_B.unpack(str[start:end])
        _v218.is_dense = bool(_v218.is_dense)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v217.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        _v221 = _v217.image
        _v222 = _v221.header
        start = end
        end += 4
        (_v222.seq,) = _struct_I.unpack(str[start:end])
        _v223 = _v222.stamp
        _x = _v223
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v222.frame_id = str[start:end].decode('utf-8')
        else:
          _v222.frame_id = str[start:end]
        _x = _v221
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v221.encoding = str[start:end].decode('utf-8')
        else:
          _v221.encoding = str[start:end]
        _x = _v221
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v221.data = str[start:end].decode('utf-8')
        else:
          _v221.data = str[start:end]
        _v224 = _v217.disparity_image
        _v225 = _v224.header
        start = end
        end += 4
        (_v225.seq,) = _struct_I.unpack(str[start:end])
        _v226 = _v225.stamp
        _x = _v226
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v225.frame_id = str[start:end].decode('utf-8')
        else:
          _v225.frame_id = str[start:end]
        _x = _v224
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v224.encoding = str[start:end].decode('utf-8')
        else:
          _v224.encoding = str[start:end]
        _x = _v224
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v224.data = str[start:end].decode('utf-8')
        else:
          _v224.data = str[start:end]
        _v227 = _v217.cam_info
        _v228 = _v227.header
        start = end
        end += 4
        (_v228.seq,) = _struct_I.unpack(str[start:end])
        _v229 = _v228.stamp
        _x = _v229
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v228.frame_id = str[start:end].decode('utf-8')
        else:
          _v228.frame_id = str[start:end]
        _x = _v227
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v227.distortion_model = str[start:end].decode('utf-8')
        else:
          _v227.distortion_model = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v227.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 72
        _v227.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 72
        _v227.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 96
        _v227.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
        _x = _v227
        start = end
        end += 8
        (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
        _v230 = _v227.roi
        _x = _v230
        start = end
        end += 17
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
        _v230.do_rectify = bool(_v230.do_rectify)
        _v231 = _v217.roi_box_pose
        _v232 = _v231.header
        start = end
        end += 4
        (_v232.seq,) = _struct_I.unpack(str[start:end])
        _v233 = _v232.stamp
        _x = _v233
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v232.frame_id = str[start:end].decode('utf-8')
        else:
          _v232.frame_id = str[start:end]
        _v234 = _v231.pose
        _v235 = _v234.position
        _x = _v235
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v236 = _v234.orientation
        _x = _v236
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v237 = _v217.roi_box_dims
        _x = _v237
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.collision_name = str[start:end].decode('utf-8')
        else:
          val1.collision_name = str[start:end]
        self.grasp.moved_obstacles.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attempted_grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v238 = val1.pre_grasp_posture
        _v239 = _v238.header
        start = end
        end += 4
        (_v239.seq,) = _struct_I.unpack(str[start:end])
        _v240 = _v239.stamp
        _x = _v240
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v239.frame_id = str[start:end].decode('utf-8')
        else:
          _v239.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v238.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v238.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v238.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v238.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v238.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v241 = val1.grasp_posture
        _v242 = _v241.header
        start = end
        end += 4
        (_v242.seq,) = _struct_I.unpack(str[start:end])
        _v243 = _v242.stamp
        _x = _v243
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v242.frame_id = str[start:end].decode('utf-8')
        else:
          _v242.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v241.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v241.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v241.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v241.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v241.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v244 = val1.grasp_pose
        _v245 = _v244.position
        _x = _v245
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v246 = _v244.orientation
        _x = _v246
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v247 = val3.pose
            _v248 = _v247.header
            start = end
            end += 4
            (_v248.seq,) = _struct_I.unpack(str[start:end])
            _v249 = _v248.stamp
            _x = _v249
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v248.frame_id = str[start:end].decode('utf-8')
            else:
              _v248.frame_id = str[start:end]
            _v250 = _v247.pose
            _v251 = _v250.position
            _x = _v251
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v252 = _v250.orientation
            _x = _v252
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v253 = val2.cluster
          _v254 = _v253.header
          start = end
          end += 4
          (_v254.seq,) = _struct_I.unpack(str[start:end])
          _v255 = _v254.stamp
          _x = _v255
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v254.frame_id = str[start:end].decode('utf-8')
          else:
            _v254.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v253.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v253.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v253.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
            _v253.channels.append(val4)
          _v256 = val2.region
          _v257 = _v256.cloud
          _v258 = _v257.header
          start = end
          end += 4
          (_v258.seq,) = _struct_I.unpack(str[start:end])
          _v259 = _v258.stamp
          _x = _v259
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v258.frame_id = str[start:end].decode('utf-8')
          else:
            _v258.frame_id = str[start:end]
          _x = _v257
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v257.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v257.fields.append(val5)
          _x = _v257
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v257.is_bigendian = bool(_v257.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v257.data = str[start:end].decode('utf-8')
          else:
            _v257.data = str[start:end]
          start = end
          end += 1
          (_v257.is_dense,) = _struct_B.unpack(str[start:end])
          _v257.is_dense = bool(_v257.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v256.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
          _v260 = _v256.image
          _v261 = _v260.header
          start = end
          end += 4
          (_v261.seq,) = _struct_I.unpack(str[start:end])
          _v262 = _v261.stamp
          _x = _v262
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v261.frame_id = str[start:end].decode('utf-8')
          else:
            _v261.frame_id = str[start:end]
          _x = _v260
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v260.encoding = str[start:end].decode('utf-8')
          else:
            _v260.encoding = str[start:end]
          _x = _v260
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v260.data = str[start:end].decode('utf-8')
          else:
            _v260.data = str[start:end]
          _v263 = _v256.disparity_image
          _v264 = _v263.header
          start = end
          end += 4
          (_v264.seq,) = _struct_I.unpack(str[start:end])
          _v265 = _v264.stamp
          _x = _v265
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v264.frame_id = str[start:end].decode('utf-8')
          else:
            _v264.frame_id = str[start:end]
          _x = _v263
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v263.encoding = str[start:end].decode('utf-8')
          else:
            _v263.encoding = str[start:end]
          _x = _v263
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v263.data = str[start:end].decode('utf-8')
          else:
            _v263.data = str[start:end]
          _v266 = _v256.cam_info
          _v267 = _v266.header
          start = end
          end += 4
          (_v267.seq,) = _struct_I.unpack(str[start:end])
          _v268 = _v267.stamp
          _x = _v268
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v267.frame_id = str[start:end].decode('utf-8')
          else:
            _v267.frame_id = str[start:end]
          _x = _v266
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v266.distortion_model = str[start:end].decode('utf-8')
          else:
            _v266.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v266.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 72
          _v266.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 72
          _v266.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 96
          _v266.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
          _x = _v266
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v269 = _v266.roi
          _x = _v269
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v269.do_rectify = bool(_v269.do_rectify)
          _v270 = _v256.roi_box_pose
          _v271 = _v270.header
          start = end
          end += 4
          (_v271.seq,) = _struct_I.unpack(str[start:end])
          _v272 = _v271.stamp
          _x = _v272
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v271.frame_id = str[start:end].decode('utf-8')
          else:
            _v271.frame_id = str[start:end]
          _v273 = _v270.pose
          _v274 = _v273.position
          _x = _v274
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v275 = _v273.orientation
          _x = _v275
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v276 = _v256.roi_box_dims
          _x = _v276
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.attempted_grasps.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.attempted_grasp_results = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspResult()
        _x = val1
        start = end
        end += 5
        (_x.result_code, _x.continuation_possible,) = _struct_iB.unpack(str[start:end])
        val1.continuation_possible = bool(val1.continuation_possible)
        self.attempted_grasp_results.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_IBI = struct.Struct("<IBI")
_struct_8dB2f = struct.Struct("<8dB2f")
_struct_12d = struct.Struct("<12d")
_struct_f = struct.Struct("<f")
_struct_i = struct.Struct("<i")
_struct_dB2f = struct.Struct("<dB2f")
_struct_3I = struct.Struct("<3I")
_struct_3f = struct.Struct("<3f")
_struct_i3I = struct.Struct("<i3I")
_struct_B = struct.Struct("<B")
_struct_9d = struct.Struct("<9d")
_struct_B2I = struct.Struct("<B2I")
_struct_4d = struct.Struct("<4d")
_struct_iB = struct.Struct("<iB")
_struct_BI = struct.Struct("<BI")
_struct_2I = struct.Struct("<2I")
_struct_4IB = struct.Struct("<4IB")
_struct_3d = struct.Struct("<3d")
