"""autogenerated by genpy from object_manipulation_msgs/GraspPlanningAction.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import object_manipulation_msgs.msg
import actionlib_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg
import genpy
import household_objects_database_msgs.msg

class GraspPlanningAction(genpy.Message):
  _md5sum = "633fe6f10f37f6a935a5aa9ae19f25c5"
  _type = "object_manipulation_msgs/GraspPlanningAction"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

GraspPlanningActionGoal action_goal
GraspPlanningActionResult action_result
GraspPlanningActionFeedback action_feedback

================================================================================
MSG: object_manipulation_msgs/GraspPlanningActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
GraspPlanningGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: object_manipulation_msgs/GraspPlanningGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Requests that grasp planning be performed on the object to be grasped
# returns a list of grasps to be tested and executed

# the arm being used
string arm_name

# the object to be grasped
GraspableObject target

# the name that the target object has in the collision environment
# can be left empty if no name is available
string collision_object_name

# the name that the support surface (e.g. table) has in the collision map
# can be left empty if no name is available
string collision_support_surface_name

# an optional list of grasps to be evaluated by the planner
Grasp[] grasps_to_evaluate

# an optional list of obstacles that we have semantic information about
# and that can be moved in the course of grasping
GraspableObject[] movable_obstacles


================================================================================
MSG: object_manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# a graspable object can be represented in multiple ways. This message
# can contain all of them. Which one is actually used is up to the receiver
# of this message. When adding new representations, one must be careful that
# they have reasonable lightweight defaults indicating that that particular
# representation is not available.

# the tf frame to be used as a reference frame when combining information from
# the different representations below
string reference_frame_id

# potential recognition results from a database of models
# all poses are relative to the object reference pose
household_objects_database_msgs/DatabaseModelPose[] potential_models

# the point cloud itself
sensor_msgs/PointCloud cluster

# a region of a PointCloud2 of interest
object_manipulation_msgs/SceneRegion region

# the name that this object has in the collision environment
string collision_name
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
# This message holds a collection of 3d points, plus optional additional
# information about each point.

# Time of sensor data acquisition, coordinate frame ID.
Header header

# Array of 3d points. Each Point32 should be interpreted as a 3d point
# in the frame given in the header.
geometry_msgs/Point32[] points

# Each channel should have the same number of elements as points array,
# and the data in each channel should correspond 1:1 with each point.
# Channel names in common practice are listed in ChannelFloat32.msg.
ChannelFloat32[] channels

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   "u", "v" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   "rgb" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   "intensity" - laser or pixel intensity.
#   "distance"

# The channel name should give semantics of the channel (e.g.
# "intensity" instead of "value").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: object_manipulation_msgs/SceneRegion
# Point cloud
sensor_msgs/PointCloud2 cloud

# Indices for the region of interest
int32[] mask

# One of the corresponding 2D images, if applicable
sensor_msgs/Image image

# The disparity image, if applicable
sensor_msgs/Image disparity_image

# Camera info for the camera that took the image
sensor_msgs/CameraInfo cam_info

# a 3D region of interest for grasp planning
geometry_msgs/PoseStamped  roi_box_pose
geometry_msgs/Vector3 	   roi_box_dims

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the "fields" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic "camera_info" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may "recalibrate" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, "plumb_bob" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For "plumb_bob", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger "super-pixels." It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the "raw"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: object_manipulation_msgs/Grasp

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/Pose grasp_pose

# The estimated probability of success for this grasp
float64 success_probability

# Debug flag to indicate that this grasp would be the best in its cluster
bool cluster_rep

# how far the pre-grasp should ideally be away from the grasp
float32 desired_approach_distance

# how much distance between pre-grasp and grasp must actually be feasible 
# for the grasp not to be rejected
float32 min_approach_distance

# an optional list of obstacles that we have semantic information about
# and that we expect might move in the course of executing this grasp
# the grasp planner is expected to make sure they move in an OK way; during
# execution, grasp executors will not check for collisions against these objects
GraspableObject[] moved_obstacles

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: object_manipulation_msgs/GraspPlanningActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: object_manipulation_msgs/GraspPlanningResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# the list of planned grasps
Grasp[] grasps

# whether an error occurred
GraspPlanningErrorCode error_code


================================================================================
MSG: object_manipulation_msgs/GraspPlanningErrorCode
# Error codes for grasp and place planning

# plan completed as expected
int32 SUCCESS = 0

# tf error encountered while transforming
int32 TF_ERROR = 1 

# some other error
int32 OTHER_ERROR = 2

# the actual value of this error code
int32 value
================================================================================
MSG: object_manipulation_msgs/GraspPlanningActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningFeedback feedback

================================================================================
MSG: object_manipulation_msgs/GraspPlanningFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# grasps planned so far
Grasp[] grasps



"""
  __slots__ = ['action_goal','action_result','action_feedback']
  _slot_types = ['object_manipulation_msgs/GraspPlanningActionGoal','object_manipulation_msgs/GraspPlanningActionResult','object_manipulation_msgs/GraspPlanningActionFeedback']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action_goal,action_result,action_feedback

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GraspPlanningAction, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.action_goal is None:
        self.action_goal = object_manipulation_msgs.msg.GraspPlanningActionGoal()
      if self.action_result is None:
        self.action_result = object_manipulation_msgs.msg.GraspPlanningActionResult()
      if self.action_feedback is None:
        self.action_feedback = object_manipulation_msgs.msg.GraspPlanningActionFeedback()
    else:
      self.action_goal = object_manipulation_msgs.msg.GraspPlanningActionGoal()
      self.action_result = object_manipulation_msgs.msg.GraspPlanningActionResult()
      self.action_feedback = object_manipulation_msgs.msg.GraspPlanningActionFeedback()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.arm_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.target.reference_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.potential_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.potential_models:
        buff.write(_struct_i.pack(val1.model_id))
        _v1 = val1.pose
        _v2 = _v1.header
        buff.write(_struct_I.pack(_v2.seq))
        _v3 = _v2.stamp
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v2.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v4 = _v1.pose
        _v5 = _v4.position
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = _v4.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.cluster.header.seq, _x.action_goal.goal.target.cluster.header.stamp.secs, _x.action_goal.goal.target.cluster.header.stamp.nsecs))
      _x = self.action_goal.goal.target.cluster.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.action_goal.goal.target.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.cluster.channels:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *val1.values))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.cloud.header.seq, _x.action_goal.goal.target.region.cloud.header.stamp.secs, _x.action_goal.goal.target.region.cloud.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.cloud.height, _x.action_goal.goal.target.region.cloud.width))
      length = len(self.action_goal.goal.target.region.cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.region.cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.action_goal.goal.target.region.cloud.is_bigendian, _x.action_goal.goal.target.region.cloud.point_step, _x.action_goal.goal.target.region.cloud.row_step))
      _x = self.action_goal.goal.target.region.cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_goal.goal.target.region.cloud.is_dense))
      length = len(self.action_goal.goal.target.region.mask)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.target.region.mask))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.image.header.seq, _x.action_goal.goal.target.region.image.header.stamp.secs, _x.action_goal.goal.target.region.image.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.image.height, _x.action_goal.goal.target.region.image.width))
      _x = self.action_goal.goal.target.region.image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.action_goal.goal.target.region.image.is_bigendian, _x.action_goal.goal.target.region.image.step))
      _x = self.action_goal.goal.target.region.image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.disparity_image.header.seq, _x.action_goal.goal.target.region.disparity_image.header.stamp.secs, _x.action_goal.goal.target.region.disparity_image.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.disparity_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.disparity_image.height, _x.action_goal.goal.target.region.disparity_image.width))
      _x = self.action_goal.goal.target.region.disparity_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.action_goal.goal.target.region.disparity_image.is_bigendian, _x.action_goal.goal.target.region.disparity_image.step))
      _x = self.action_goal.goal.target.region.disparity_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.cam_info.header.seq, _x.action_goal.goal.target.region.cam_info.header.stamp.secs, _x.action_goal.goal.target.region.cam_info.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.cam_info.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.cam_info.height, _x.action_goal.goal.target.region.cam_info.width))
      _x = self.action_goal.goal.target.region.cam_info.distortion_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.region.cam_info.D)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.action_goal.goal.target.region.cam_info.D))
      buff.write(_struct_9d.pack(*self.action_goal.goal.target.region.cam_info.K))
      buff.write(_struct_9d.pack(*self.action_goal.goal.target.region.cam_info.R))
      buff.write(_struct_12d.pack(*self.action_goal.goal.target.region.cam_info.P))
      _x = self
      buff.write(_struct_6IB3I.pack(_x.action_goal.goal.target.region.cam_info.binning_x, _x.action_goal.goal.target.region.cam_info.binning_y, _x.action_goal.goal.target.region.cam_info.roi.x_offset, _x.action_goal.goal.target.region.cam_info.roi.y_offset, _x.action_goal.goal.target.region.cam_info.roi.height, _x.action_goal.goal.target.region.cam_info.roi.width, _x.action_goal.goal.target.region.cam_info.roi.do_rectify, _x.action_goal.goal.target.region.roi_box_pose.header.seq, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.secs, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.roi_box_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d.pack(_x.action_goal.goal.target.region.roi_box_pose.pose.position.x, _x.action_goal.goal.target.region.roi_box_pose.pose.position.y, _x.action_goal.goal.target.region.roi_box_pose.pose.position.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.x, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.y, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.w, _x.action_goal.goal.target.region.roi_box_dims.x, _x.action_goal.goal.target.region.roi_box_dims.y, _x.action_goal.goal.target.region.roi_box_dims.z))
      _x = self.action_goal.goal.target.collision_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.collision_object_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.collision_support_surface_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.grasps_to_evaluate)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.grasps_to_evaluate:
        _v7 = val1.pre_grasp_posture
        _v8 = _v7.header
        buff.write(_struct_I.pack(_v8.seq))
        _v9 = _v8.stamp
        _x = _v9
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v8.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v7.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v7.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v7.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v7.position))
        length = len(_v7.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v7.velocity))
        length = len(_v7.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v7.effort))
        _v10 = val1.grasp_posture
        _v11 = _v10.header
        buff.write(_struct_I.pack(_v11.seq))
        _v12 = _v11.stamp
        _x = _v12
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v11.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v10.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v10.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v10.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v10.position))
        length = len(_v10.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v10.velocity))
        length = len(_v10.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v10.effort))
        _v13 = val1.grasp_pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v16 = val3.pose
            _v17 = _v16.header
            buff.write(_struct_I.pack(_v17.seq))
            _v18 = _v17.stamp
            _x = _v18
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v17.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v19 = _v16.pose
            _v20 = _v19.position
            _x = _v20
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v21 = _v19.orientation
            _x = _v21
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v22 = val2.cluster
          _v23 = _v22.header
          buff.write(_struct_I.pack(_v23.seq))
          _v24 = _v23.stamp
          _x = _v24
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v23.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v22.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v22.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v22.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v22.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(struct.pack(pattern, *val4.values))
          _v25 = val2.region
          _v26 = _v25.cloud
          _v27 = _v26.header
          buff.write(_struct_I.pack(_v27.seq))
          _v28 = _v27.stamp
          _x = _v28
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v27.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v26
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v26.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v26.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v26
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v26.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v26.is_dense))
          length = len(_v25.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(struct.pack(pattern, *_v25.mask))
          _v29 = _v25.image
          _v30 = _v29.header
          buff.write(_struct_I.pack(_v30.seq))
          _v31 = _v30.stamp
          _x = _v31
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v30.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v29
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v29.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v29
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v29.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v32 = _v25.disparity_image
          _v33 = _v32.header
          buff.write(_struct_I.pack(_v33.seq))
          _v34 = _v33.stamp
          _x = _v34
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v33.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v32
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v32.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v32
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v32.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v35 = _v25.cam_info
          _v36 = _v35.header
          buff.write(_struct_I.pack(_v36.seq))
          _v37 = _v36.stamp
          _x = _v37
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v36.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v35
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v35.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v35.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *_v35.D))
          buff.write(_struct_9d.pack(*_v35.K))
          buff.write(_struct_9d.pack(*_v35.R))
          buff.write(_struct_12d.pack(*_v35.P))
          _x = _v35
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v38 = _v35.roi
          _x = _v38
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v39 = _v25.roi_box_pose
          _v40 = _v39.header
          buff.write(_struct_I.pack(_v40.seq))
          _v41 = _v40.stamp
          _x = _v41
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v40.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v42 = _v39.pose
          _v43 = _v42.position
          _x = _v43
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v44 = _v42.orientation
          _x = _v44
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v45 = _v25.roi_box_dims
          _x = _v45
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.movable_obstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.movable_obstacles:
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.potential_models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.potential_models:
          buff.write(_struct_i.pack(val2.model_id))
          _v46 = val2.pose
          _v47 = _v46.header
          buff.write(_struct_I.pack(_v47.seq))
          _v48 = _v47.stamp
          _x = _v48
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v47.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v49 = _v46.pose
          _v50 = _v49.position
          _x = _v50
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v51 = _v49.orientation
          _x = _v51
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v52 = val1.cluster
        _v53 = _v52.header
        buff.write(_struct_I.pack(_v53.seq))
        _v54 = _v53.stamp
        _x = _v54
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v53.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v52.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v52.points:
          _x = val3
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        length = len(_v52.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v52.channels:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(struct.pack(pattern, *val3.values))
        _v55 = val1.region
        _v56 = _v55.cloud
        _v57 = _v56.header
        buff.write(_struct_I.pack(_v57.seq))
        _v58 = _v57.stamp
        _x = _v58
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v57.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v56
        buff.write(_struct_2I.pack(_x.height, _x.width))
        length = len(_v56.fields)
        buff.write(_struct_I.pack(length))
        for val4 in _v56.fields:
          _x = val4.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val4
          buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
        _x = _v56
        buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v56.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(_v56.is_dense))
        length = len(_v55.mask)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *_v55.mask))
        _v59 = _v55.image
        _v60 = _v59.header
        buff.write(_struct_I.pack(_v60.seq))
        _v61 = _v60.stamp
        _x = _v61
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v60.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v59
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v59.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v59
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v59.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v62 = _v55.disparity_image
        _v63 = _v62.header
        buff.write(_struct_I.pack(_v63.seq))
        _v64 = _v63.stamp
        _x = _v64
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v63.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v62
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v62.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v62
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v62.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v65 = _v55.cam_info
        _v66 = _v65.header
        buff.write(_struct_I.pack(_v66.seq))
        _v67 = _v66.stamp
        _x = _v67
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v66.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v65
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v65.distortion_model
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v65.D)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v65.D))
        buff.write(_struct_9d.pack(*_v65.K))
        buff.write(_struct_9d.pack(*_v65.R))
        buff.write(_struct_12d.pack(*_v65.P))
        _x = _v65
        buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
        _v68 = _v65.roi
        _x = _v68
        buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v69 = _v55.roi_box_pose
        _v70 = _v69.header
        buff.write(_struct_I.pack(_v70.seq))
        _v71 = _v70.stamp
        _x = _v71
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v70.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v72 = _v69.pose
        _v73 = _v72.position
        _x = _v73
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v74 = _v72.orientation
        _x = _v74
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v75 = _v55.roi_box_dims
        _x = _v75
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_result.status.status))
      _x = self.action_result.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_result.result.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_result.result.grasps:
        _v76 = val1.pre_grasp_posture
        _v77 = _v76.header
        buff.write(_struct_I.pack(_v77.seq))
        _v78 = _v77.stamp
        _x = _v78
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v77.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v76.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v76.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v76.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v76.position))
        length = len(_v76.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v76.velocity))
        length = len(_v76.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v76.effort))
        _v79 = val1.grasp_posture
        _v80 = _v79.header
        buff.write(_struct_I.pack(_v80.seq))
        _v81 = _v80.stamp
        _x = _v81
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v80.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v79.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v79.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v79.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v79.position))
        length = len(_v79.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v79.velocity))
        length = len(_v79.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v79.effort))
        _v82 = val1.grasp_pose
        _v83 = _v82.position
        _x = _v83
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v84 = _v82.orientation
        _x = _v84
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v85 = val3.pose
            _v86 = _v85.header
            buff.write(_struct_I.pack(_v86.seq))
            _v87 = _v86.stamp
            _x = _v87
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v86.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v88 = _v85.pose
            _v89 = _v88.position
            _x = _v89
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v90 = _v88.orientation
            _x = _v90
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v91 = val2.cluster
          _v92 = _v91.header
          buff.write(_struct_I.pack(_v92.seq))
          _v93 = _v92.stamp
          _x = _v93
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v92.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v91.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v91.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v91.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v91.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(struct.pack(pattern, *val4.values))
          _v94 = val2.region
          _v95 = _v94.cloud
          _v96 = _v95.header
          buff.write(_struct_I.pack(_v96.seq))
          _v97 = _v96.stamp
          _x = _v97
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v96.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v95
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v95.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v95.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v95
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v95.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v95.is_dense))
          length = len(_v94.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(struct.pack(pattern, *_v94.mask))
          _v98 = _v94.image
          _v99 = _v98.header
          buff.write(_struct_I.pack(_v99.seq))
          _v100 = _v99.stamp
          _x = _v100
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v99.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v98
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v98.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v98
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v98.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v101 = _v94.disparity_image
          _v102 = _v101.header
          buff.write(_struct_I.pack(_v102.seq))
          _v103 = _v102.stamp
          _x = _v103
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v102.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v101
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v101.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v101
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v101.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v104 = _v94.cam_info
          _v105 = _v104.header
          buff.write(_struct_I.pack(_v105.seq))
          _v106 = _v105.stamp
          _x = _v106
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v105.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v104
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v104.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v104.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *_v104.D))
          buff.write(_struct_9d.pack(*_v104.K))
          buff.write(_struct_9d.pack(*_v104.R))
          buff.write(_struct_12d.pack(*_v104.P))
          _x = _v104
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v107 = _v104.roi
          _x = _v107
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v108 = _v94.roi_box_pose
          _v109 = _v108.header
          buff.write(_struct_I.pack(_v109.seq))
          _v110 = _v109.stamp
          _x = _v110
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v109.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v111 = _v108.pose
          _v112 = _v111.position
          _x = _v112
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v113 = _v111.orientation
          _x = _v113
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v114 = _v94.roi_box_dims
          _x = _v114
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_i3I.pack(_x.action_result.result.error_code.value, _x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_feedback.status.status))
      _x = self.action_feedback.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_feedback.feedback.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_feedback.feedback.grasps:
        _v115 = val1.pre_grasp_posture
        _v116 = _v115.header
        buff.write(_struct_I.pack(_v116.seq))
        _v117 = _v116.stamp
        _x = _v117
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v116.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v115.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v115.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v115.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v115.position))
        length = len(_v115.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v115.velocity))
        length = len(_v115.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v115.effort))
        _v118 = val1.grasp_posture
        _v119 = _v118.header
        buff.write(_struct_I.pack(_v119.seq))
        _v120 = _v119.stamp
        _x = _v120
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v119.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v118.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v118.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v118.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v118.position))
        length = len(_v118.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v118.velocity))
        length = len(_v118.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v118.effort))
        _v121 = val1.grasp_pose
        _v122 = _v121.position
        _x = _v122
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v123 = _v121.orientation
        _x = _v123
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v124 = val3.pose
            _v125 = _v124.header
            buff.write(_struct_I.pack(_v125.seq))
            _v126 = _v125.stamp
            _x = _v126
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v125.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v127 = _v124.pose
            _v128 = _v127.position
            _x = _v128
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v129 = _v127.orientation
            _x = _v129
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v130 = val2.cluster
          _v131 = _v130.header
          buff.write(_struct_I.pack(_v131.seq))
          _v132 = _v131.stamp
          _x = _v132
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v131.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v130.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v130.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v130.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v130.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(struct.pack(pattern, *val4.values))
          _v133 = val2.region
          _v134 = _v133.cloud
          _v135 = _v134.header
          buff.write(_struct_I.pack(_v135.seq))
          _v136 = _v135.stamp
          _x = _v136
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v135.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v134
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v134.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v134.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v134
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v134.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v134.is_dense))
          length = len(_v133.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(struct.pack(pattern, *_v133.mask))
          _v137 = _v133.image
          _v138 = _v137.header
          buff.write(_struct_I.pack(_v138.seq))
          _v139 = _v138.stamp
          _x = _v139
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v138.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v137
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v137.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v137
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v137.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v140 = _v133.disparity_image
          _v141 = _v140.header
          buff.write(_struct_I.pack(_v141.seq))
          _v142 = _v141.stamp
          _x = _v142
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v141.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v140
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v140.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v140
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v140.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v143 = _v133.cam_info
          _v144 = _v143.header
          buff.write(_struct_I.pack(_v144.seq))
          _v145 = _v144.stamp
          _x = _v145
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v144.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v143
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v143.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v143.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *_v143.D))
          buff.write(_struct_9d.pack(*_v143.K))
          buff.write(_struct_9d.pack(*_v143.R))
          buff.write(_struct_12d.pack(*_v143.P))
          _x = _v143
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v146 = _v143.roi
          _x = _v146
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v147 = _v133.roi_box_pose
          _v148 = _v147.header
          buff.write(_struct_I.pack(_v148.seq))
          _v149 = _v148.stamp
          _x = _v149
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v148.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v150 = _v147.pose
          _v151 = _v150.position
          _x = _v151
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v152 = _v150.orientation
          _x = _v152
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v153 = _v133.roi_box_dims
          _x = _v153
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.action_goal is None:
        self.action_goal = object_manipulation_msgs.msg.GraspPlanningActionGoal()
      if self.action_result is None:
        self.action_result = object_manipulation_msgs.msg.GraspPlanningActionResult()
      if self.action_feedback is None:
        self.action_feedback = object_manipulation_msgs.msg.GraspPlanningActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal_id.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.arm_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.arm_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.reference_frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.reference_frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.potential_models = []
      for i in range(0, length):
        val1 = household_objects_database_msgs.msg.DatabaseModelPose()
        start = end
        end += 4
        (val1.model_id,) = _struct_i.unpack(str[start:end])
        _v154 = val1.pose
        _v155 = _v154.header
        start = end
        end += 4
        (_v155.seq,) = _struct_I.unpack(str[start:end])
        _v156 = _v155.stamp
        _x = _v156
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v155.frame_id = str[start:end].decode('utf-8')
        else:
          _v155.frame_id = str[start:end]
        _v157 = _v154.pose
        _v158 = _v157.position
        _x = _v158
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v159 = _v157.orientation
        _x = _v159
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (val1.confidence,) = _struct_f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.detector_name = str[start:end].decode('utf-8')
        else:
          val1.detector_name = str[start:end]
        self.action_goal.goal.target.potential_models.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.cluster.header.seq, _x.action_goal.goal.target.cluster.header.stamp.secs, _x.action_goal.goal.target.cluster.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.cluster.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.cluster.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.action_goal.goal.target.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.cluster.channels = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = struct.unpack(pattern, str[start:end])
        self.action_goal.goal.target.cluster.channels.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.cloud.header.seq, _x.action_goal.goal.target.region.cloud.header.stamp.secs, _x.action_goal.goal.target.region.cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.cloud.height, _x.action_goal.goal.target.region.cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.action_goal.goal.target.region.cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.action_goal.goal.target.region.cloud.is_bigendian, _x.action_goal.goal.target.region.cloud.point_step, _x.action_goal.goal.target.region.cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.is_bigendian = bool(self.action_goal.goal.target.region.cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cloud.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cloud.data = str[start:end]
      start = end
      end += 1
      (self.action_goal.goal.target.region.cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.is_dense = bool(self.action_goal.goal.target.region.cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.target.region.mask = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.image.header.seq, _x.action_goal.goal.target.region.image.header.stamp.secs, _x.action_goal.goal.target.region.image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.image.height, _x.action_goal.goal.target.region.image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.encoding = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.action_goal.goal.target.region.image.is_bigendian, _x.action_goal.goal.target.region.image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.disparity_image.header.seq, _x.action_goal.goal.target.region.disparity_image.header.stamp.secs, _x.action_goal.goal.target.region.disparity_image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.disparity_image.height, _x.action_goal.goal.target.region.disparity_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.encoding = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.action_goal.goal.target.region.disparity_image.is_bigendian, _x.action_goal.goal.target.region.disparity_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.cam_info.header.seq, _x.action_goal.goal.target.region.cam_info.header.stamp.secs, _x.action_goal.goal.target.region.cam_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cam_info.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cam_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.cam_info.height, _x.action_goal.goal.target.region.cam_info.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cam_info.distortion_model = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cam_info.distortion_model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.target.region.cam_info.D = struct.unpack(pattern, str[start:end])
      start = end
      end += 72
      self.action_goal.goal.target.region.cam_info.K = _struct_9d.unpack(str[start:end])
      start = end
      end += 72
      self.action_goal.goal.target.region.cam_info.R = _struct_9d.unpack(str[start:end])
      start = end
      end += 96
      self.action_goal.goal.target.region.cam_info.P = _struct_12d.unpack(str[start:end])
      _x = self
      start = end
      end += 37
      (_x.action_goal.goal.target.region.cam_info.binning_x, _x.action_goal.goal.target.region.cam_info.binning_y, _x.action_goal.goal.target.region.cam_info.roi.x_offset, _x.action_goal.goal.target.region.cam_info.roi.y_offset, _x.action_goal.goal.target.region.cam_info.roi.height, _x.action_goal.goal.target.region.cam_info.roi.width, _x.action_goal.goal.target.region.cam_info.roi.do_rectify, _x.action_goal.goal.target.region.roi_box_pose.header.seq, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.secs, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs,) = _struct_6IB3I.unpack(str[start:end])
      self.action_goal.goal.target.region.cam_info.roi.do_rectify = bool(self.action_goal.goal.target.region.cam_info.roi.do_rectify)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.roi_box_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.roi_box_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.action_goal.goal.target.region.roi_box_pose.pose.position.x, _x.action_goal.goal.target.region.roi_box_pose.pose.position.y, _x.action_goal.goal.target.region.roi_box_pose.pose.position.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.x, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.y, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.w, _x.action_goal.goal.target.region.roi_box_dims.x, _x.action_goal.goal.target.region.roi_box_dims.y, _x.action_goal.goal.target.region.roi_box_dims.z,) = _struct_10d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.collision_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.collision_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.collision_object_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.collision_object_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.collision_support_surface_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.collision_support_surface_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.grasps_to_evaluate = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v160 = val1.pre_grasp_posture
        _v161 = _v160.header
        start = end
        end += 4
        (_v161.seq,) = _struct_I.unpack(str[start:end])
        _v162 = _v161.stamp
        _x = _v162
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v161.frame_id = str[start:end].decode('utf-8')
        else:
          _v161.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v160.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v160.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v160.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v160.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v160.effort = struct.unpack(pattern, str[start:end])
        _v163 = val1.grasp_posture
        _v164 = _v163.header
        start = end
        end += 4
        (_v164.seq,) = _struct_I.unpack(str[start:end])
        _v165 = _v164.stamp
        _x = _v165
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v164.frame_id = str[start:end].decode('utf-8')
        else:
          _v164.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v163.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v163.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v163.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v163.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v163.effort = struct.unpack(pattern, str[start:end])
        _v166 = val1.grasp_pose
        _v167 = _v166.position
        _x = _v167
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v168 = _v166.orientation
        _x = _v168
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v169 = val3.pose
            _v170 = _v169.header
            start = end
            end += 4
            (_v170.seq,) = _struct_I.unpack(str[start:end])
            _v171 = _v170.stamp
            _x = _v171
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v170.frame_id = str[start:end].decode('utf-8')
            else:
              _v170.frame_id = str[start:end]
            _v172 = _v169.pose
            _v173 = _v172.position
            _x = _v173
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v174 = _v172.orientation
            _x = _v174
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v175 = val2.cluster
          _v176 = _v175.header
          start = end
          end += 4
          (_v176.seq,) = _struct_I.unpack(str[start:end])
          _v177 = _v176.stamp
          _x = _v177
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v176.frame_id = str[start:end].decode('utf-8')
          else:
            _v176.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v175.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v175.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v175.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = struct.unpack(pattern, str[start:end])
            _v175.channels.append(val4)
          _v178 = val2.region
          _v179 = _v178.cloud
          _v180 = _v179.header
          start = end
          end += 4
          (_v180.seq,) = _struct_I.unpack(str[start:end])
          _v181 = _v180.stamp
          _x = _v181
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v180.frame_id = str[start:end].decode('utf-8')
          else:
            _v180.frame_id = str[start:end]
          _x = _v179
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v179.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v179.fields.append(val5)
          _x = _v179
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v179.is_bigendian = bool(_v179.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v179.data = str[start:end].decode('utf-8')
          else:
            _v179.data = str[start:end]
          start = end
          end += 1
          (_v179.is_dense,) = _struct_B.unpack(str[start:end])
          _v179.is_dense = bool(_v179.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v178.mask = struct.unpack(pattern, str[start:end])
          _v182 = _v178.image
          _v183 = _v182.header
          start = end
          end += 4
          (_v183.seq,) = _struct_I.unpack(str[start:end])
          _v184 = _v183.stamp
          _x = _v184
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v183.frame_id = str[start:end].decode('utf-8')
          else:
            _v183.frame_id = str[start:end]
          _x = _v182
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v182.encoding = str[start:end].decode('utf-8')
          else:
            _v182.encoding = str[start:end]
          _x = _v182
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v182.data = str[start:end].decode('utf-8')
          else:
            _v182.data = str[start:end]
          _v185 = _v178.disparity_image
          _v186 = _v185.header
          start = end
          end += 4
          (_v186.seq,) = _struct_I.unpack(str[start:end])
          _v187 = _v186.stamp
          _x = _v187
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v186.frame_id = str[start:end].decode('utf-8')
          else:
            _v186.frame_id = str[start:end]
          _x = _v185
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v185.encoding = str[start:end].decode('utf-8')
          else:
            _v185.encoding = str[start:end]
          _x = _v185
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v185.data = str[start:end].decode('utf-8')
          else:
            _v185.data = str[start:end]
          _v188 = _v178.cam_info
          _v189 = _v188.header
          start = end
          end += 4
          (_v189.seq,) = _struct_I.unpack(str[start:end])
          _v190 = _v189.stamp
          _x = _v190
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v189.frame_id = str[start:end].decode('utf-8')
          else:
            _v189.frame_id = str[start:end]
          _x = _v188
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v188.distortion_model = str[start:end].decode('utf-8')
          else:
            _v188.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v188.D = struct.unpack(pattern, str[start:end])
          start = end
          end += 72
          _v188.K = _struct_9d.unpack(str[start:end])
          start = end
          end += 72
          _v188.R = _struct_9d.unpack(str[start:end])
          start = end
          end += 96
          _v188.P = _struct_12d.unpack(str[start:end])
          _x = _v188
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v191 = _v188.roi
          _x = _v191
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v191.do_rectify = bool(_v191.do_rectify)
          _v192 = _v178.roi_box_pose
          _v193 = _v192.header
          start = end
          end += 4
          (_v193.seq,) = _struct_I.unpack(str[start:end])
          _v194 = _v193.stamp
          _x = _v194
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v193.frame_id = str[start:end].decode('utf-8')
          else:
            _v193.frame_id = str[start:end]
          _v195 = _v192.pose
          _v196 = _v195.position
          _x = _v196
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v197 = _v195.orientation
          _x = _v197
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v198 = _v178.roi_box_dims
          _x = _v198
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_goal.goal.grasps_to_evaluate.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.movable_obstacles = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspableObject()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.potential_models = []
        for i in range(0, length):
          val2 = household_objects_database_msgs.msg.DatabaseModelPose()
          start = end
          end += 4
          (val2.model_id,) = _struct_i.unpack(str[start:end])
          _v199 = val2.pose
          _v200 = _v199.header
          start = end
          end += 4
          (_v200.seq,) = _struct_I.unpack(str[start:end])
          _v201 = _v200.stamp
          _x = _v201
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v200.frame_id = str[start:end].decode('utf-8')
          else:
            _v200.frame_id = str[start:end]
          _v202 = _v199.pose
          _v203 = _v202.position
          _x = _v203
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v204 = _v202.orientation
          _x = _v204
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.confidence,) = _struct_f.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detector_name = str[start:end].decode('utf-8')
          else:
            val2.detector_name = str[start:end]
          val1.potential_models.append(val2)
        _v205 = val1.cluster
        _v206 = _v205.header
        start = end
        end += 4
        (_v206.seq,) = _struct_I.unpack(str[start:end])
        _v207 = _v206.stamp
        _x = _v207
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v206.frame_id = str[start:end].decode('utf-8')
        else:
          _v206.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v205.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v205.points.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v205.channels = []
        for i in range(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = struct.unpack(pattern, str[start:end])
          _v205.channels.append(val3)
        _v208 = val1.region
        _v209 = _v208.cloud
        _v210 = _v209.header
        start = end
        end += 4
        (_v210.seq,) = _struct_I.unpack(str[start:end])
        _v211 = _v210.stamp
        _x = _v211
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v210.frame_id = str[start:end].decode('utf-8')
        else:
          _v210.frame_id = str[start:end]
        _x = _v209
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v209.fields = []
        for i in range(0, length):
          val4 = sensor_msgs.msg.PointField()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.name = str[start:end].decode('utf-8')
          else:
            val4.name = str[start:end]
          _x = val4
          start = end
          end += 9
          (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
          _v209.fields.append(val4)
        _x = _v209
        start = end
        end += 9
        (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
        _v209.is_bigendian = bool(_v209.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v209.data = str[start:end].decode('utf-8')
        else:
          _v209.data = str[start:end]
        start = end
        end += 1
        (_v209.is_dense,) = _struct_B.unpack(str[start:end])
        _v209.is_dense = bool(_v209.is_dense)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v208.mask = struct.unpack(pattern, str[start:end])
        _v212 = _v208.image
        _v213 = _v212.header
        start = end
        end += 4
        (_v213.seq,) = _struct_I.unpack(str[start:end])
        _v214 = _v213.stamp
        _x = _v214
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v213.frame_id = str[start:end].decode('utf-8')
        else:
          _v213.frame_id = str[start:end]
        _x = _v212
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v212.encoding = str[start:end].decode('utf-8')
        else:
          _v212.encoding = str[start:end]
        _x = _v212
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v212.data = str[start:end].decode('utf-8')
        else:
          _v212.data = str[start:end]
        _v215 = _v208.disparity_image
        _v216 = _v215.header
        start = end
        end += 4
        (_v216.seq,) = _struct_I.unpack(str[start:end])
        _v217 = _v216.stamp
        _x = _v217
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v216.frame_id = str[start:end].decode('utf-8')
        else:
          _v216.frame_id = str[start:end]
        _x = _v215
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v215.encoding = str[start:end].decode('utf-8')
        else:
          _v215.encoding = str[start:end]
        _x = _v215
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v215.data = str[start:end].decode('utf-8')
        else:
          _v215.data = str[start:end]
        _v218 = _v208.cam_info
        _v219 = _v218.header
        start = end
        end += 4
        (_v219.seq,) = _struct_I.unpack(str[start:end])
        _v220 = _v219.stamp
        _x = _v220
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v219.frame_id = str[start:end].decode('utf-8')
        else:
          _v219.frame_id = str[start:end]
        _x = _v218
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v218.distortion_model = str[start:end].decode('utf-8')
        else:
          _v218.distortion_model = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v218.D = struct.unpack(pattern, str[start:end])
        start = end
        end += 72
        _v218.K = _struct_9d.unpack(str[start:end])
        start = end
        end += 72
        _v218.R = _struct_9d.unpack(str[start:end])
        start = end
        end += 96
        _v218.P = _struct_12d.unpack(str[start:end])
        _x = _v218
        start = end
        end += 8
        (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
        _v221 = _v218.roi
        _x = _v221
        start = end
        end += 17
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
        _v221.do_rectify = bool(_v221.do_rectify)
        _v222 = _v208.roi_box_pose
        _v223 = _v222.header
        start = end
        end += 4
        (_v223.seq,) = _struct_I.unpack(str[start:end])
        _v224 = _v223.stamp
        _x = _v224
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v223.frame_id = str[start:end].decode('utf-8')
        else:
          _v223.frame_id = str[start:end]
        _v225 = _v222.pose
        _v226 = _v225.position
        _x = _v226
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v227 = _v225.orientation
        _x = _v227
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v228 = _v208.roi_box_dims
        _x = _v228
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.collision_name = str[start:end].decode('utf-8')
        else:
          val1.collision_name = str[start:end]
        self.action_goal.goal.movable_obstacles.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.text = str[start:end].decode('utf-8')
      else:
        self.action_result.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_result.result.grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v229 = val1.pre_grasp_posture
        _v230 = _v229.header
        start = end
        end += 4
        (_v230.seq,) = _struct_I.unpack(str[start:end])
        _v231 = _v230.stamp
        _x = _v231
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v230.frame_id = str[start:end].decode('utf-8')
        else:
          _v230.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v229.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v229.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v229.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v229.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v229.effort = struct.unpack(pattern, str[start:end])
        _v232 = val1.grasp_posture
        _v233 = _v232.header
        start = end
        end += 4
        (_v233.seq,) = _struct_I.unpack(str[start:end])
        _v234 = _v233.stamp
        _x = _v234
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v233.frame_id = str[start:end].decode('utf-8')
        else:
          _v233.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v232.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v232.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v232.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v232.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v232.effort = struct.unpack(pattern, str[start:end])
        _v235 = val1.grasp_pose
        _v236 = _v235.position
        _x = _v236
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v237 = _v235.orientation
        _x = _v237
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v238 = val3.pose
            _v239 = _v238.header
            start = end
            end += 4
            (_v239.seq,) = _struct_I.unpack(str[start:end])
            _v240 = _v239.stamp
            _x = _v240
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v239.frame_id = str[start:end].decode('utf-8')
            else:
              _v239.frame_id = str[start:end]
            _v241 = _v238.pose
            _v242 = _v241.position
            _x = _v242
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v243 = _v241.orientation
            _x = _v243
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v244 = val2.cluster
          _v245 = _v244.header
          start = end
          end += 4
          (_v245.seq,) = _struct_I.unpack(str[start:end])
          _v246 = _v245.stamp
          _x = _v246
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v245.frame_id = str[start:end].decode('utf-8')
          else:
            _v245.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v244.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v244.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v244.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = struct.unpack(pattern, str[start:end])
            _v244.channels.append(val4)
          _v247 = val2.region
          _v248 = _v247.cloud
          _v249 = _v248.header
          start = end
          end += 4
          (_v249.seq,) = _struct_I.unpack(str[start:end])
          _v250 = _v249.stamp
          _x = _v250
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v249.frame_id = str[start:end].decode('utf-8')
          else:
            _v249.frame_id = str[start:end]
          _x = _v248
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v248.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v248.fields.append(val5)
          _x = _v248
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v248.is_bigendian = bool(_v248.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v248.data = str[start:end].decode('utf-8')
          else:
            _v248.data = str[start:end]
          start = end
          end += 1
          (_v248.is_dense,) = _struct_B.unpack(str[start:end])
          _v248.is_dense = bool(_v248.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v247.mask = struct.unpack(pattern, str[start:end])
          _v251 = _v247.image
          _v252 = _v251.header
          start = end
          end += 4
          (_v252.seq,) = _struct_I.unpack(str[start:end])
          _v253 = _v252.stamp
          _x = _v253
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v252.frame_id = str[start:end].decode('utf-8')
          else:
            _v252.frame_id = str[start:end]
          _x = _v251
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v251.encoding = str[start:end].decode('utf-8')
          else:
            _v251.encoding = str[start:end]
          _x = _v251
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v251.data = str[start:end].decode('utf-8')
          else:
            _v251.data = str[start:end]
          _v254 = _v247.disparity_image
          _v255 = _v254.header
          start = end
          end += 4
          (_v255.seq,) = _struct_I.unpack(str[start:end])
          _v256 = _v255.stamp
          _x = _v256
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v255.frame_id = str[start:end].decode('utf-8')
          else:
            _v255.frame_id = str[start:end]
          _x = _v254
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v254.encoding = str[start:end].decode('utf-8')
          else:
            _v254.encoding = str[start:end]
          _x = _v254
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v254.data = str[start:end].decode('utf-8')
          else:
            _v254.data = str[start:end]
          _v257 = _v247.cam_info
          _v258 = _v257.header
          start = end
          end += 4
          (_v258.seq,) = _struct_I.unpack(str[start:end])
          _v259 = _v258.stamp
          _x = _v259
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v258.frame_id = str[start:end].decode('utf-8')
          else:
            _v258.frame_id = str[start:end]
          _x = _v257
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v257.distortion_model = str[start:end].decode('utf-8')
          else:
            _v257.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v257.D = struct.unpack(pattern, str[start:end])
          start = end
          end += 72
          _v257.K = _struct_9d.unpack(str[start:end])
          start = end
          end += 72
          _v257.R = _struct_9d.unpack(str[start:end])
          start = end
          end += 96
          _v257.P = _struct_12d.unpack(str[start:end])
          _x = _v257
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v260 = _v257.roi
          _x = _v260
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v260.do_rectify = bool(_v260.do_rectify)
          _v261 = _v247.roi_box_pose
          _v262 = _v261.header
          start = end
          end += 4
          (_v262.seq,) = _struct_I.unpack(str[start:end])
          _v263 = _v262.stamp
          _x = _v263
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v262.frame_id = str[start:end].decode('utf-8')
          else:
            _v262.frame_id = str[start:end]
          _v264 = _v261.pose
          _v265 = _v264.position
          _x = _v265
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v266 = _v264.orientation
          _x = _v266
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v267 = _v247.roi_box_dims
          _x = _v267
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_result.result.grasps.append(val1)
      _x = self
      start = end
      end += 16
      (_x.action_result.result.error_code.value, _x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.text = str[start:end].decode('utf-8')
      else:
        self.action_feedback.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_feedback.feedback.grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v268 = val1.pre_grasp_posture
        _v269 = _v268.header
        start = end
        end += 4
        (_v269.seq,) = _struct_I.unpack(str[start:end])
        _v270 = _v269.stamp
        _x = _v270
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v269.frame_id = str[start:end].decode('utf-8')
        else:
          _v269.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v268.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v268.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v268.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v268.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v268.effort = struct.unpack(pattern, str[start:end])
        _v271 = val1.grasp_posture
        _v272 = _v271.header
        start = end
        end += 4
        (_v272.seq,) = _struct_I.unpack(str[start:end])
        _v273 = _v272.stamp
        _x = _v273
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v272.frame_id = str[start:end].decode('utf-8')
        else:
          _v272.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v271.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v271.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v271.position = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v271.velocity = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v271.effort = struct.unpack(pattern, str[start:end])
        _v274 = val1.grasp_pose
        _v275 = _v274.position
        _x = _v275
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v276 = _v274.orientation
        _x = _v276
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v277 = val3.pose
            _v278 = _v277.header
            start = end
            end += 4
            (_v278.seq,) = _struct_I.unpack(str[start:end])
            _v279 = _v278.stamp
            _x = _v279
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v278.frame_id = str[start:end].decode('utf-8')
            else:
              _v278.frame_id = str[start:end]
            _v280 = _v277.pose
            _v281 = _v280.position
            _x = _v281
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v282 = _v280.orientation
            _x = _v282
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v283 = val2.cluster
          _v284 = _v283.header
          start = end
          end += 4
          (_v284.seq,) = _struct_I.unpack(str[start:end])
          _v285 = _v284.stamp
          _x = _v285
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v284.frame_id = str[start:end].decode('utf-8')
          else:
            _v284.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v283.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v283.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v283.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = struct.unpack(pattern, str[start:end])
            _v283.channels.append(val4)
          _v286 = val2.region
          _v287 = _v286.cloud
          _v288 = _v287.header
          start = end
          end += 4
          (_v288.seq,) = _struct_I.unpack(str[start:end])
          _v289 = _v288.stamp
          _x = _v289
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v288.frame_id = str[start:end].decode('utf-8')
          else:
            _v288.frame_id = str[start:end]
          _x = _v287
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v287.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v287.fields.append(val5)
          _x = _v287
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v287.is_bigendian = bool(_v287.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v287.data = str[start:end].decode('utf-8')
          else:
            _v287.data = str[start:end]
          start = end
          end += 1
          (_v287.is_dense,) = _struct_B.unpack(str[start:end])
          _v287.is_dense = bool(_v287.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v286.mask = struct.unpack(pattern, str[start:end])
          _v290 = _v286.image
          _v291 = _v290.header
          start = end
          end += 4
          (_v291.seq,) = _struct_I.unpack(str[start:end])
          _v292 = _v291.stamp
          _x = _v292
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v291.frame_id = str[start:end].decode('utf-8')
          else:
            _v291.frame_id = str[start:end]
          _x = _v290
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v290.encoding = str[start:end].decode('utf-8')
          else:
            _v290.encoding = str[start:end]
          _x = _v290
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v290.data = str[start:end].decode('utf-8')
          else:
            _v290.data = str[start:end]
          _v293 = _v286.disparity_image
          _v294 = _v293.header
          start = end
          end += 4
          (_v294.seq,) = _struct_I.unpack(str[start:end])
          _v295 = _v294.stamp
          _x = _v295
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v294.frame_id = str[start:end].decode('utf-8')
          else:
            _v294.frame_id = str[start:end]
          _x = _v293
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v293.encoding = str[start:end].decode('utf-8')
          else:
            _v293.encoding = str[start:end]
          _x = _v293
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v293.data = str[start:end].decode('utf-8')
          else:
            _v293.data = str[start:end]
          _v296 = _v286.cam_info
          _v297 = _v296.header
          start = end
          end += 4
          (_v297.seq,) = _struct_I.unpack(str[start:end])
          _v298 = _v297.stamp
          _x = _v298
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v297.frame_id = str[start:end].decode('utf-8')
          else:
            _v297.frame_id = str[start:end]
          _x = _v296
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v296.distortion_model = str[start:end].decode('utf-8')
          else:
            _v296.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v296.D = struct.unpack(pattern, str[start:end])
          start = end
          end += 72
          _v296.K = _struct_9d.unpack(str[start:end])
          start = end
          end += 72
          _v296.R = _struct_9d.unpack(str[start:end])
          start = end
          end += 96
          _v296.P = _struct_12d.unpack(str[start:end])
          _x = _v296
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v299 = _v296.roi
          _x = _v299
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v299.do_rectify = bool(_v299.do_rectify)
          _v300 = _v286.roi_box_pose
          _v301 = _v300.header
          start = end
          end += 4
          (_v301.seq,) = _struct_I.unpack(str[start:end])
          _v302 = _v301.stamp
          _x = _v302
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v301.frame_id = str[start:end].decode('utf-8')
          else:
            _v301.frame_id = str[start:end]
          _v303 = _v300.pose
          _v304 = _v303.position
          _x = _v304
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v305 = _v303.orientation
          _x = _v305
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v306 = _v286.roi_box_dims
          _x = _v306
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_feedback.feedback.grasps.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs))
      _x = self.action_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs))
      _x = self.action_goal.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.arm_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.target.reference_frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.potential_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.potential_models:
        buff.write(_struct_i.pack(val1.model_id))
        _v307 = val1.pose
        _v308 = _v307.header
        buff.write(_struct_I.pack(_v308.seq))
        _v309 = _v308.stamp
        _x = _v309
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v308.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v310 = _v307.pose
        _v311 = _v310.position
        _x = _v311
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v312 = _v310.orientation
        _x = _v312
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(_struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.cluster.header.seq, _x.action_goal.goal.target.cluster.header.stamp.secs, _x.action_goal.goal.target.cluster.header.stamp.nsecs))
      _x = self.action_goal.goal.target.cluster.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.cluster.points)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.cluster.points:
        _x = val1
        buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
      length = len(self.action_goal.goal.target.cluster.channels)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.cluster.channels:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.values)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(val1.values.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.cloud.header.seq, _x.action_goal.goal.target.region.cloud.header.stamp.secs, _x.action_goal.goal.target.region.cloud.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.cloud.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.cloud.height, _x.action_goal.goal.target.region.cloud.width))
      length = len(self.action_goal.goal.target.region.cloud.fields)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.target.region.cloud.fields:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1
        buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
      _x = self
      buff.write(_struct_B2I.pack(_x.action_goal.goal.target.region.cloud.is_bigendian, _x.action_goal.goal.target.region.cloud.point_step, _x.action_goal.goal.target.region.cloud.row_step))
      _x = self.action_goal.goal.target.region.cloud.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_goal.goal.target.region.cloud.is_dense))
      length = len(self.action_goal.goal.target.region.mask)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.action_goal.goal.target.region.mask.tostring())
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.image.header.seq, _x.action_goal.goal.target.region.image.header.stamp.secs, _x.action_goal.goal.target.region.image.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.image.height, _x.action_goal.goal.target.region.image.width))
      _x = self.action_goal.goal.target.region.image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.action_goal.goal.target.region.image.is_bigendian, _x.action_goal.goal.target.region.image.step))
      _x = self.action_goal.goal.target.region.image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.disparity_image.header.seq, _x.action_goal.goal.target.region.disparity_image.header.stamp.secs, _x.action_goal.goal.target.region.disparity_image.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.disparity_image.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.disparity_image.height, _x.action_goal.goal.target.region.disparity_image.width))
      _x = self.action_goal.goal.target.region.disparity_image.encoding
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_BI.pack(_x.action_goal.goal.target.region.disparity_image.is_bigendian, _x.action_goal.goal.target.region.disparity_image.step))
      _x = self.action_goal.goal.target.region.disparity_image.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_goal.goal.target.region.cam_info.header.seq, _x.action_goal.goal.target.region.cam_info.header.stamp.secs, _x.action_goal.goal.target.region.cam_info.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.cam_info.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_goal.goal.target.region.cam_info.height, _x.action_goal.goal.target.region.cam_info.width))
      _x = self.action_goal.goal.target.region.cam_info.distortion_model
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.target.region.cam_info.D)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.action_goal.goal.target.region.cam_info.D.tostring())
      buff.write(self.action_goal.goal.target.region.cam_info.K.tostring())
      buff.write(self.action_goal.goal.target.region.cam_info.R.tostring())
      buff.write(self.action_goal.goal.target.region.cam_info.P.tostring())
      _x = self
      buff.write(_struct_6IB3I.pack(_x.action_goal.goal.target.region.cam_info.binning_x, _x.action_goal.goal.target.region.cam_info.binning_y, _x.action_goal.goal.target.region.cam_info.roi.x_offset, _x.action_goal.goal.target.region.cam_info.roi.y_offset, _x.action_goal.goal.target.region.cam_info.roi.height, _x.action_goal.goal.target.region.cam_info.roi.width, _x.action_goal.goal.target.region.cam_info.roi.do_rectify, _x.action_goal.goal.target.region.roi_box_pose.header.seq, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.secs, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs))
      _x = self.action_goal.goal.target.region.roi_box_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_10d.pack(_x.action_goal.goal.target.region.roi_box_pose.pose.position.x, _x.action_goal.goal.target.region.roi_box_pose.pose.position.y, _x.action_goal.goal.target.region.roi_box_pose.pose.position.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.x, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.y, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.w, _x.action_goal.goal.target.region.roi_box_dims.x, _x.action_goal.goal.target.region.roi_box_dims.y, _x.action_goal.goal.target.region.roi_box_dims.z))
      _x = self.action_goal.goal.target.collision_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.collision_object_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.action_goal.goal.collision_support_surface_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.grasps_to_evaluate)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.grasps_to_evaluate:
        _v313 = val1.pre_grasp_posture
        _v314 = _v313.header
        buff.write(_struct_I.pack(_v314.seq))
        _v315 = _v314.stamp
        _x = _v315
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v314.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v313.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v313.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v313.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v313.position.tostring())
        length = len(_v313.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v313.velocity.tostring())
        length = len(_v313.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v313.effort.tostring())
        _v316 = val1.grasp_posture
        _v317 = _v316.header
        buff.write(_struct_I.pack(_v317.seq))
        _v318 = _v317.stamp
        _x = _v318
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v317.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v316.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v316.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v316.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v316.position.tostring())
        length = len(_v316.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v316.velocity.tostring())
        length = len(_v316.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v316.effort.tostring())
        _v319 = val1.grasp_pose
        _v320 = _v319.position
        _x = _v320
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v321 = _v319.orientation
        _x = _v321
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v322 = val3.pose
            _v323 = _v322.header
            buff.write(_struct_I.pack(_v323.seq))
            _v324 = _v323.stamp
            _x = _v324
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v323.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v325 = _v322.pose
            _v326 = _v325.position
            _x = _v326
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v327 = _v325.orientation
            _x = _v327
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v328 = val2.cluster
          _v329 = _v328.header
          buff.write(_struct_I.pack(_v329.seq))
          _v330 = _v329.stamp
          _x = _v330
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v329.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v328.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v328.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v328.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v328.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(val4.values.tostring())
          _v331 = val2.region
          _v332 = _v331.cloud
          _v333 = _v332.header
          buff.write(_struct_I.pack(_v333.seq))
          _v334 = _v333.stamp
          _x = _v334
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v333.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v332
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v332.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v332.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v332
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v332.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v332.is_dense))
          length = len(_v331.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(_v331.mask.tostring())
          _v335 = _v331.image
          _v336 = _v335.header
          buff.write(_struct_I.pack(_v336.seq))
          _v337 = _v336.stamp
          _x = _v337
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v336.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v335
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v335.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v335
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v335.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v338 = _v331.disparity_image
          _v339 = _v338.header
          buff.write(_struct_I.pack(_v339.seq))
          _v340 = _v339.stamp
          _x = _v340
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v339.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v338
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v338.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v338
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v338.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v341 = _v331.cam_info
          _v342 = _v341.header
          buff.write(_struct_I.pack(_v342.seq))
          _v343 = _v342.stamp
          _x = _v343
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v342.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v341
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v341.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v341.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(_v341.D.tostring())
          buff.write(_v341.K.tostring())
          buff.write(_v341.R.tostring())
          buff.write(_v341.P.tostring())
          _x = _v341
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v344 = _v341.roi
          _x = _v344
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v345 = _v331.roi_box_pose
          _v346 = _v345.header
          buff.write(_struct_I.pack(_v346.seq))
          _v347 = _v346.stamp
          _x = _v347
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v346.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v348 = _v345.pose
          _v349 = _v348.position
          _x = _v349
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v350 = _v348.orientation
          _x = _v350
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v351 = _v331.roi_box_dims
          _x = _v351
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_goal.goal.movable_obstacles)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_goal.goal.movable_obstacles:
        _x = val1.reference_frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(val1.potential_models)
        buff.write(_struct_I.pack(length))
        for val2 in val1.potential_models:
          buff.write(_struct_i.pack(val2.model_id))
          _v352 = val2.pose
          _v353 = _v352.header
          buff.write(_struct_I.pack(_v353.seq))
          _v354 = _v353.stamp
          _x = _v354
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v353.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v355 = _v352.pose
          _v356 = _v355.position
          _x = _v356
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v357 = _v355.orientation
          _x = _v357
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(_struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v358 = val1.cluster
        _v359 = _v358.header
        buff.write(_struct_I.pack(_v359.seq))
        _v360 = _v359.stamp
        _x = _v360
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v359.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v358.points)
        buff.write(_struct_I.pack(length))
        for val3 in _v358.points:
          _x = val3
          buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
        length = len(_v358.channels)
        buff.write(_struct_I.pack(length))
        for val3 in _v358.channels:
          _x = val3.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val3.values)
          buff.write(_struct_I.pack(length))
          pattern = '<%sf'%length
          buff.write(val3.values.tostring())
        _v361 = val1.region
        _v362 = _v361.cloud
        _v363 = _v362.header
        buff.write(_struct_I.pack(_v363.seq))
        _v364 = _v363.stamp
        _x = _v364
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v363.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v362
        buff.write(_struct_2I.pack(_x.height, _x.width))
        length = len(_v362.fields)
        buff.write(_struct_I.pack(length))
        for val4 in _v362.fields:
          _x = val4.name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = val4
          buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
        _x = _v362
        buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v362.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        buff.write(_struct_B.pack(_v362.is_dense))
        length = len(_v361.mask)
        buff.write(_struct_I.pack(length))
        pattern = '<%si'%length
        buff.write(_v361.mask.tostring())
        _v365 = _v361.image
        _v366 = _v365.header
        buff.write(_struct_I.pack(_v366.seq))
        _v367 = _v366.stamp
        _x = _v367
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v366.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v365
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v365.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v365
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v365.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v368 = _v361.disparity_image
        _v369 = _v368.header
        buff.write(_struct_I.pack(_v369.seq))
        _v370 = _v369.stamp
        _x = _v370
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v369.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v368
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v368.encoding
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v368
        buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
        _x = _v368.data
        length = len(_x)
        # - if encoded as a list instead, serialize as bytes instead of string
        if type(_x) in [list, tuple]:
          buff.write(struct.pack('<I%sB'%length, length, *_x))
        else:
          buff.write(struct.pack('<I%ss'%length, length, _x))
        _v371 = _v361.cam_info
        _v372 = _v371.header
        buff.write(_struct_I.pack(_v372.seq))
        _v373 = _v372.stamp
        _x = _v373
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v372.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v371
        buff.write(_struct_2I.pack(_x.height, _x.width))
        _x = _v371.distortion_model
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v371.D)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v371.D.tostring())
        buff.write(_v371.K.tostring())
        buff.write(_v371.R.tostring())
        buff.write(_v371.P.tostring())
        _x = _v371
        buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
        _v374 = _v371.roi
        _x = _v374
        buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v375 = _v361.roi_box_pose
        _v376 = _v375.header
        buff.write(_struct_I.pack(_v376.seq))
        _v377 = _v376.stamp
        _x = _v377
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v376.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v378 = _v375.pose
        _v379 = _v378.position
        _x = _v379
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v380 = _v378.orientation
        _x = _v380
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _v381 = _v361.roi_box_dims
        _x = _v381
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs))
      _x = self.action_result.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs))
      _x = self.action_result.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_result.status.status))
      _x = self.action_result.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_result.result.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_result.result.grasps:
        _v382 = val1.pre_grasp_posture
        _v383 = _v382.header
        buff.write(_struct_I.pack(_v383.seq))
        _v384 = _v383.stamp
        _x = _v384
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v383.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v382.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v382.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v382.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v382.position.tostring())
        length = len(_v382.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v382.velocity.tostring())
        length = len(_v382.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v382.effort.tostring())
        _v385 = val1.grasp_posture
        _v386 = _v385.header
        buff.write(_struct_I.pack(_v386.seq))
        _v387 = _v386.stamp
        _x = _v387
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v386.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v385.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v385.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v385.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v385.position.tostring())
        length = len(_v385.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v385.velocity.tostring())
        length = len(_v385.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v385.effort.tostring())
        _v388 = val1.grasp_pose
        _v389 = _v388.position
        _x = _v389
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v390 = _v388.orientation
        _x = _v390
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v391 = val3.pose
            _v392 = _v391.header
            buff.write(_struct_I.pack(_v392.seq))
            _v393 = _v392.stamp
            _x = _v393
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v392.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v394 = _v391.pose
            _v395 = _v394.position
            _x = _v395
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v396 = _v394.orientation
            _x = _v396
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v397 = val2.cluster
          _v398 = _v397.header
          buff.write(_struct_I.pack(_v398.seq))
          _v399 = _v398.stamp
          _x = _v399
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v398.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v397.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v397.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v397.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v397.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(val4.values.tostring())
          _v400 = val2.region
          _v401 = _v400.cloud
          _v402 = _v401.header
          buff.write(_struct_I.pack(_v402.seq))
          _v403 = _v402.stamp
          _x = _v403
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v402.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v401
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v401.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v401.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v401
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v401.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v401.is_dense))
          length = len(_v400.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(_v400.mask.tostring())
          _v404 = _v400.image
          _v405 = _v404.header
          buff.write(_struct_I.pack(_v405.seq))
          _v406 = _v405.stamp
          _x = _v406
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v405.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v404
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v404.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v404
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v404.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v407 = _v400.disparity_image
          _v408 = _v407.header
          buff.write(_struct_I.pack(_v408.seq))
          _v409 = _v408.stamp
          _x = _v409
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v408.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v407
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v407.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v407
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v407.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v410 = _v400.cam_info
          _v411 = _v410.header
          buff.write(_struct_I.pack(_v411.seq))
          _v412 = _v411.stamp
          _x = _v412
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v411.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v410
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v410.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v410.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(_v410.D.tostring())
          buff.write(_v410.K.tostring())
          buff.write(_v410.R.tostring())
          buff.write(_v410.P.tostring())
          _x = _v410
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v413 = _v410.roi
          _x = _v413
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v414 = _v400.roi_box_pose
          _v415 = _v414.header
          buff.write(_struct_I.pack(_v415.seq))
          _v416 = _v415.stamp
          _x = _v416
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v415.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v417 = _v414.pose
          _v418 = _v417.position
          _x = _v418
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v419 = _v417.orientation
          _x = _v419
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v420 = _v400.roi_box_dims
          _x = _v420
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_i3I.pack(_x.action_result.result.error_code.value, _x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs))
      _x = self.action_feedback.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2I.pack(_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs))
      _x = self.action_feedback.status.goal_id.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_B.pack(self.action_feedback.status.status))
      _x = self.action_feedback.status.text
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.action_feedback.feedback.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.action_feedback.feedback.grasps:
        _v421 = val1.pre_grasp_posture
        _v422 = _v421.header
        buff.write(_struct_I.pack(_v422.seq))
        _v423 = _v422.stamp
        _x = _v423
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v422.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v421.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v421.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v421.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v421.position.tostring())
        length = len(_v421.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v421.velocity.tostring())
        length = len(_v421.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v421.effort.tostring())
        _v424 = val1.grasp_posture
        _v425 = _v424.header
        buff.write(_struct_I.pack(_v425.seq))
        _v426 = _v425.stamp
        _x = _v426
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v425.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        length = len(_v424.name)
        buff.write(_struct_I.pack(length))
        for val3 in _v424.name:
          length = len(val3)
          if python3 or type(val3) == unicode:
            val3 = val3.encode('utf-8')
            length = len(val3)
          buff.write(struct.pack('<I%ss'%length, length, val3))
        length = len(_v424.position)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v424.position.tostring())
        length = len(_v424.velocity)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v424.velocity.tostring())
        length = len(_v424.effort)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v424.effort.tostring())
        _v427 = val1.grasp_pose
        _v428 = _v427.position
        _x = _v428
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v429 = _v427.orientation
        _x = _v429
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_struct_dB2f.pack(_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance))
        length = len(val1.moved_obstacles)
        buff.write(_struct_I.pack(length))
        for val2 in val1.moved_obstacles:
          _x = val2.reference_frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(val2.potential_models)
          buff.write(_struct_I.pack(length))
          for val3 in val2.potential_models:
            buff.write(_struct_i.pack(val3.model_id))
            _v430 = val3.pose
            _v431 = _v430.header
            buff.write(_struct_I.pack(_v431.seq))
            _v432 = _v431.stamp
            _x = _v432
            buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
            _x = _v431.frame_id
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _v433 = _v430.pose
            _v434 = _v433.position
            _x = _v434
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
            _v435 = _v433.orientation
            _x = _v435
            buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
            buff.write(_struct_f.pack(val3.confidence))
            _x = val3.detector_name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v436 = val2.cluster
          _v437 = _v436.header
          buff.write(_struct_I.pack(_v437.seq))
          _v438 = _v437.stamp
          _x = _v438
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v437.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v436.points)
          buff.write(_struct_I.pack(length))
          for val4 in _v436.points:
            _x = val4
            buff.write(_struct_3f.pack(_x.x, _x.y, _x.z))
          length = len(_v436.channels)
          buff.write(_struct_I.pack(length))
          for val4 in _v436.channels:
            _x = val4.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            length = len(val4.values)
            buff.write(_struct_I.pack(length))
            pattern = '<%sf'%length
            buff.write(val4.values.tostring())
          _v439 = val2.region
          _v440 = _v439.cloud
          _v441 = _v440.header
          buff.write(_struct_I.pack(_v441.seq))
          _v442 = _v441.stamp
          _x = _v442
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v441.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v440
          buff.write(_struct_2I.pack(_x.height, _x.width))
          length = len(_v440.fields)
          buff.write(_struct_I.pack(length))
          for val5 in _v440.fields:
            _x = val5.name
            length = len(_x)
            if python3 or type(_x) == unicode:
              _x = _x.encode('utf-8')
              length = len(_x)
            buff.write(struct.pack('<I%ss'%length, length, _x))
            _x = val5
            buff.write(_struct_IBI.pack(_x.offset, _x.datatype, _x.count))
          _x = _v440
          buff.write(_struct_B2I.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = _v440.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          buff.write(_struct_B.pack(_v440.is_dense))
          length = len(_v439.mask)
          buff.write(_struct_I.pack(length))
          pattern = '<%si'%length
          buff.write(_v439.mask.tostring())
          _v443 = _v439.image
          _v444 = _v443.header
          buff.write(_struct_I.pack(_v444.seq))
          _v445 = _v444.stamp
          _x = _v445
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v444.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v443
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v443.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v443
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v443.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v446 = _v439.disparity_image
          _v447 = _v446.header
          buff.write(_struct_I.pack(_v447.seq))
          _v448 = _v447.stamp
          _x = _v448
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v447.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v446
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v446.encoding
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v446
          buff.write(_struct_BI.pack(_x.is_bigendian, _x.step))
          _x = _v446.data
          length = len(_x)
          # - if encoded as a list instead, serialize as bytes instead of string
          if type(_x) in [list, tuple]:
            buff.write(struct.pack('<I%sB'%length, length, *_x))
          else:
            buff.write(struct.pack('<I%ss'%length, length, _x))
          _v449 = _v439.cam_info
          _v450 = _v449.header
          buff.write(_struct_I.pack(_v450.seq))
          _v451 = _v450.stamp
          _x = _v451
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v450.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _x = _v449
          buff.write(_struct_2I.pack(_x.height, _x.width))
          _x = _v449.distortion_model
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          length = len(_v449.D)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(_v449.D.tostring())
          buff.write(_v449.K.tostring())
          buff.write(_v449.R.tostring())
          buff.write(_v449.P.tostring())
          _x = _v449
          buff.write(_struct_2I.pack(_x.binning_x, _x.binning_y))
          _v452 = _v449.roi
          _x = _v452
          buff.write(_struct_4IB.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
          _v453 = _v439.roi_box_pose
          _v454 = _v453.header
          buff.write(_struct_I.pack(_v454.seq))
          _v455 = _v454.stamp
          _x = _v455
          buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
          _x = _v454.frame_id
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
          _v456 = _v453.pose
          _v457 = _v456.position
          _x = _v457
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _v458 = _v456.orientation
          _x = _v458
          buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
          _v459 = _v439.roi_box_dims
          _x = _v459
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2.collision_name
          length = len(_x)
          if python3 or type(_x) == unicode:
            _x = _x.encode('utf-8')
            length = len(_x)
          buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.action_goal is None:
        self.action_goal = object_manipulation_msgs.msg.GraspPlanningActionGoal()
      if self.action_result is None:
        self.action_result = object_manipulation_msgs.msg.GraspPlanningActionResult()
      if self.action_feedback is None:
        self.action_feedback = object_manipulation_msgs.msg.GraspPlanningActionFeedback()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.action_goal.header.seq, _x.action_goal.header.stamp.secs, _x.action_goal.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal_id.stamp.secs, _x.action_goal.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal_id.id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.arm_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.arm_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.reference_frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.reference_frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.potential_models = []
      for i in range(0, length):
        val1 = household_objects_database_msgs.msg.DatabaseModelPose()
        start = end
        end += 4
        (val1.model_id,) = _struct_i.unpack(str[start:end])
        _v460 = val1.pose
        _v461 = _v460.header
        start = end
        end += 4
        (_v461.seq,) = _struct_I.unpack(str[start:end])
        _v462 = _v461.stamp
        _x = _v462
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v461.frame_id = str[start:end].decode('utf-8')
        else:
          _v461.frame_id = str[start:end]
        _v463 = _v460.pose
        _v464 = _v463.position
        _x = _v464
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v465 = _v463.orientation
        _x = _v465
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (val1.confidence,) = _struct_f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.detector_name = str[start:end].decode('utf-8')
        else:
          val1.detector_name = str[start:end]
        self.action_goal.goal.target.potential_models.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.cluster.header.seq, _x.action_goal.goal.target.cluster.header.stamp.secs, _x.action_goal.goal.target.cluster.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.cluster.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.cluster.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.cluster.points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point32()
        _x = val1
        start = end
        end += 12
        (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
        self.action_goal.goal.target.cluster.points.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.cluster.channels = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.ChannelFloat32()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        val1.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        self.action_goal.goal.target.cluster.channels.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.cloud.header.seq, _x.action_goal.goal.target.region.cloud.header.stamp.secs, _x.action_goal.goal.target.region.cloud.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cloud.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cloud.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.cloud.height, _x.action_goal.goal.target.region.cloud.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.fields = []
      for i in range(0, length):
        val1 = sensor_msgs.msg.PointField()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        _x = val1
        start = end
        end += 9
        (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
        self.action_goal.goal.target.region.cloud.fields.append(val1)
      _x = self
      start = end
      end += 9
      (_x.action_goal.goal.target.region.cloud.is_bigendian, _x.action_goal.goal.target.region.cloud.point_step, _x.action_goal.goal.target.region.cloud.row_step,) = _struct_B2I.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.is_bigendian = bool(self.action_goal.goal.target.region.cloud.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cloud.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cloud.data = str[start:end]
      start = end
      end += 1
      (self.action_goal.goal.target.region.cloud.is_dense,) = _struct_B.unpack(str[start:end])
      self.action_goal.goal.target.region.cloud.is_dense = bool(self.action_goal.goal.target.region.cloud.is_dense)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.target.region.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.image.header.seq, _x.action_goal.goal.target.region.image.header.stamp.secs, _x.action_goal.goal.target.region.image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.image.height, _x.action_goal.goal.target.region.image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.encoding = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.action_goal.goal.target.region.image.is_bigendian, _x.action_goal.goal.target.region.image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.image.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.disparity_image.header.seq, _x.action_goal.goal.target.region.disparity_image.header.stamp.secs, _x.action_goal.goal.target.region.disparity_image.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.disparity_image.height, _x.action_goal.goal.target.region.disparity_image.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.encoding = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.encoding = str[start:end]
      _x = self
      start = end
      end += 5
      (_x.action_goal.goal.target.region.disparity_image.is_bigendian, _x.action_goal.goal.target.region.disparity_image.step,) = _struct_BI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.disparity_image.data = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.disparity_image.data = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.action_goal.goal.target.region.cam_info.header.seq, _x.action_goal.goal.target.region.cam_info.header.stamp.secs, _x.action_goal.goal.target.region.cam_info.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cam_info.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cam_info.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_goal.goal.target.region.cam_info.height, _x.action_goal.goal.target.region.cam_info.width,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.cam_info.distortion_model = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.cam_info.distortion_model = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.action_goal.goal.target.region.cam_info.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 72
      self.action_goal.goal.target.region.cam_info.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 72
      self.action_goal.goal.target.region.cam_info.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
      start = end
      end += 96
      self.action_goal.goal.target.region.cam_info.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
      _x = self
      start = end
      end += 37
      (_x.action_goal.goal.target.region.cam_info.binning_x, _x.action_goal.goal.target.region.cam_info.binning_y, _x.action_goal.goal.target.region.cam_info.roi.x_offset, _x.action_goal.goal.target.region.cam_info.roi.y_offset, _x.action_goal.goal.target.region.cam_info.roi.height, _x.action_goal.goal.target.region.cam_info.roi.width, _x.action_goal.goal.target.region.cam_info.roi.do_rectify, _x.action_goal.goal.target.region.roi_box_pose.header.seq, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.secs, _x.action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs,) = _struct_6IB3I.unpack(str[start:end])
      self.action_goal.goal.target.region.cam_info.roi.do_rectify = bool(self.action_goal.goal.target.region.cam_info.roi.do_rectify)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.region.roi_box_pose.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.region.roi_box_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.action_goal.goal.target.region.roi_box_pose.pose.position.x, _x.action_goal.goal.target.region.roi_box_pose.pose.position.y, _x.action_goal.goal.target.region.roi_box_pose.pose.position.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.x, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.y, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.z, _x.action_goal.goal.target.region.roi_box_pose.pose.orientation.w, _x.action_goal.goal.target.region.roi_box_dims.x, _x.action_goal.goal.target.region.roi_box_dims.y, _x.action_goal.goal.target.region.roi_box_dims.z,) = _struct_10d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.target.collision_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.target.collision_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.collision_object_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.collision_object_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_goal.goal.collision_support_surface_name = str[start:end].decode('utf-8')
      else:
        self.action_goal.goal.collision_support_surface_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.grasps_to_evaluate = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v466 = val1.pre_grasp_posture
        _v467 = _v466.header
        start = end
        end += 4
        (_v467.seq,) = _struct_I.unpack(str[start:end])
        _v468 = _v467.stamp
        _x = _v468
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v467.frame_id = str[start:end].decode('utf-8')
        else:
          _v467.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v466.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v466.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v466.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v466.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v466.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v469 = val1.grasp_posture
        _v470 = _v469.header
        start = end
        end += 4
        (_v470.seq,) = _struct_I.unpack(str[start:end])
        _v471 = _v470.stamp
        _x = _v471
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v470.frame_id = str[start:end].decode('utf-8')
        else:
          _v470.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v469.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v469.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v469.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v469.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v469.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v472 = val1.grasp_pose
        _v473 = _v472.position
        _x = _v473
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v474 = _v472.orientation
        _x = _v474
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v475 = val3.pose
            _v476 = _v475.header
            start = end
            end += 4
            (_v476.seq,) = _struct_I.unpack(str[start:end])
            _v477 = _v476.stamp
            _x = _v477
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v476.frame_id = str[start:end].decode('utf-8')
            else:
              _v476.frame_id = str[start:end]
            _v478 = _v475.pose
            _v479 = _v478.position
            _x = _v479
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v480 = _v478.orientation
            _x = _v480
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v481 = val2.cluster
          _v482 = _v481.header
          start = end
          end += 4
          (_v482.seq,) = _struct_I.unpack(str[start:end])
          _v483 = _v482.stamp
          _x = _v483
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v482.frame_id = str[start:end].decode('utf-8')
          else:
            _v482.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v481.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v481.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v481.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
            _v481.channels.append(val4)
          _v484 = val2.region
          _v485 = _v484.cloud
          _v486 = _v485.header
          start = end
          end += 4
          (_v486.seq,) = _struct_I.unpack(str[start:end])
          _v487 = _v486.stamp
          _x = _v487
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v486.frame_id = str[start:end].decode('utf-8')
          else:
            _v486.frame_id = str[start:end]
          _x = _v485
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v485.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v485.fields.append(val5)
          _x = _v485
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v485.is_bigendian = bool(_v485.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v485.data = str[start:end].decode('utf-8')
          else:
            _v485.data = str[start:end]
          start = end
          end += 1
          (_v485.is_dense,) = _struct_B.unpack(str[start:end])
          _v485.is_dense = bool(_v485.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v484.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
          _v488 = _v484.image
          _v489 = _v488.header
          start = end
          end += 4
          (_v489.seq,) = _struct_I.unpack(str[start:end])
          _v490 = _v489.stamp
          _x = _v490
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v489.frame_id = str[start:end].decode('utf-8')
          else:
            _v489.frame_id = str[start:end]
          _x = _v488
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v488.encoding = str[start:end].decode('utf-8')
          else:
            _v488.encoding = str[start:end]
          _x = _v488
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v488.data = str[start:end].decode('utf-8')
          else:
            _v488.data = str[start:end]
          _v491 = _v484.disparity_image
          _v492 = _v491.header
          start = end
          end += 4
          (_v492.seq,) = _struct_I.unpack(str[start:end])
          _v493 = _v492.stamp
          _x = _v493
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v492.frame_id = str[start:end].decode('utf-8')
          else:
            _v492.frame_id = str[start:end]
          _x = _v491
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v491.encoding = str[start:end].decode('utf-8')
          else:
            _v491.encoding = str[start:end]
          _x = _v491
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v491.data = str[start:end].decode('utf-8')
          else:
            _v491.data = str[start:end]
          _v494 = _v484.cam_info
          _v495 = _v494.header
          start = end
          end += 4
          (_v495.seq,) = _struct_I.unpack(str[start:end])
          _v496 = _v495.stamp
          _x = _v496
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v495.frame_id = str[start:end].decode('utf-8')
          else:
            _v495.frame_id = str[start:end]
          _x = _v494
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v494.distortion_model = str[start:end].decode('utf-8')
          else:
            _v494.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v494.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 72
          _v494.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 72
          _v494.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 96
          _v494.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
          _x = _v494
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v497 = _v494.roi
          _x = _v497
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v497.do_rectify = bool(_v497.do_rectify)
          _v498 = _v484.roi_box_pose
          _v499 = _v498.header
          start = end
          end += 4
          (_v499.seq,) = _struct_I.unpack(str[start:end])
          _v500 = _v499.stamp
          _x = _v500
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v499.frame_id = str[start:end].decode('utf-8')
          else:
            _v499.frame_id = str[start:end]
          _v501 = _v498.pose
          _v502 = _v501.position
          _x = _v502
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v503 = _v501.orientation
          _x = _v503
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v504 = _v484.roi_box_dims
          _x = _v504
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_goal.goal.grasps_to_evaluate.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_goal.goal.movable_obstacles = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.GraspableObject()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.reference_frame_id = str[start:end].decode('utf-8')
        else:
          val1.reference_frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.potential_models = []
        for i in range(0, length):
          val2 = household_objects_database_msgs.msg.DatabaseModelPose()
          start = end
          end += 4
          (val2.model_id,) = _struct_i.unpack(str[start:end])
          _v505 = val2.pose
          _v506 = _v505.header
          start = end
          end += 4
          (_v506.seq,) = _struct_I.unpack(str[start:end])
          _v507 = _v506.stamp
          _x = _v507
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v506.frame_id = str[start:end].decode('utf-8')
          else:
            _v506.frame_id = str[start:end]
          _v508 = _v505.pose
          _v509 = _v508.position
          _x = _v509
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v510 = _v508.orientation
          _x = _v510
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          start = end
          end += 4
          (val2.confidence,) = _struct_f.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.detector_name = str[start:end].decode('utf-8')
          else:
            val2.detector_name = str[start:end]
          val1.potential_models.append(val2)
        _v511 = val1.cluster
        _v512 = _v511.header
        start = end
        end += 4
        (_v512.seq,) = _struct_I.unpack(str[start:end])
        _v513 = _v512.stamp
        _x = _v513
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v512.frame_id = str[start:end].decode('utf-8')
        else:
          _v512.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v511.points = []
        for i in range(0, length):
          val3 = geometry_msgs.msg.Point32()
          _x = val3
          start = end
          end += 12
          (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
          _v511.points.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v511.channels = []
        for i in range(0, length):
          val3 = sensor_msgs.msg.ChannelFloat32()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3.name = str[start:end].decode('utf-8')
          else:
            val3.name = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sf'%length
          start = end
          end += struct.calcsize(pattern)
          val3.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
          _v511.channels.append(val3)
        _v514 = val1.region
        _v515 = _v514.cloud
        _v516 = _v515.header
        start = end
        end += 4
        (_v516.seq,) = _struct_I.unpack(str[start:end])
        _v517 = _v516.stamp
        _x = _v517
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v516.frame_id = str[start:end].decode('utf-8')
        else:
          _v516.frame_id = str[start:end]
        _x = _v515
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v515.fields = []
        for i in range(0, length):
          val4 = sensor_msgs.msg.PointField()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val4.name = str[start:end].decode('utf-8')
          else:
            val4.name = str[start:end]
          _x = val4
          start = end
          end += 9
          (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
          _v515.fields.append(val4)
        _x = _v515
        start = end
        end += 9
        (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
        _v515.is_bigendian = bool(_v515.is_bigendian)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v515.data = str[start:end].decode('utf-8')
        else:
          _v515.data = str[start:end]
        start = end
        end += 1
        (_v515.is_dense,) = _struct_B.unpack(str[start:end])
        _v515.is_dense = bool(_v515.is_dense)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        _v514.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        _v518 = _v514.image
        _v519 = _v518.header
        start = end
        end += 4
        (_v519.seq,) = _struct_I.unpack(str[start:end])
        _v520 = _v519.stamp
        _x = _v520
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v519.frame_id = str[start:end].decode('utf-8')
        else:
          _v519.frame_id = str[start:end]
        _x = _v518
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v518.encoding = str[start:end].decode('utf-8')
        else:
          _v518.encoding = str[start:end]
        _x = _v518
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v518.data = str[start:end].decode('utf-8')
        else:
          _v518.data = str[start:end]
        _v521 = _v514.disparity_image
        _v522 = _v521.header
        start = end
        end += 4
        (_v522.seq,) = _struct_I.unpack(str[start:end])
        _v523 = _v522.stamp
        _x = _v523
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v522.frame_id = str[start:end].decode('utf-8')
        else:
          _v522.frame_id = str[start:end]
        _x = _v521
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v521.encoding = str[start:end].decode('utf-8')
        else:
          _v521.encoding = str[start:end]
        _x = _v521
        start = end
        end += 5
        (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v521.data = str[start:end].decode('utf-8')
        else:
          _v521.data = str[start:end]
        _v524 = _v514.cam_info
        _v525 = _v524.header
        start = end
        end += 4
        (_v525.seq,) = _struct_I.unpack(str[start:end])
        _v526 = _v525.stamp
        _x = _v526
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v525.frame_id = str[start:end].decode('utf-8')
        else:
          _v525.frame_id = str[start:end]
        _x = _v524
        start = end
        end += 8
        (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v524.distortion_model = str[start:end].decode('utf-8')
        else:
          _v524.distortion_model = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v524.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 72
        _v524.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 72
        _v524.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
        start = end
        end += 96
        _v524.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
        _x = _v524
        start = end
        end += 8
        (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
        _v527 = _v524.roi
        _x = _v527
        start = end
        end += 17
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
        _v527.do_rectify = bool(_v527.do_rectify)
        _v528 = _v514.roi_box_pose
        _v529 = _v528.header
        start = end
        end += 4
        (_v529.seq,) = _struct_I.unpack(str[start:end])
        _v530 = _v529.stamp
        _x = _v530
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v529.frame_id = str[start:end].decode('utf-8')
        else:
          _v529.frame_id = str[start:end]
        _v531 = _v528.pose
        _v532 = _v531.position
        _x = _v532
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v533 = _v531.orientation
        _x = _v533
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _v534 = _v514.roi_box_dims
        _x = _v534
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.collision_name = str[start:end].decode('utf-8')
        else:
          val1.collision_name = str[start:end]
        self.action_goal.goal.movable_obstacles.append(val1)
      _x = self
      start = end
      end += 12
      (_x.action_result.header.seq, _x.action_result.header.stamp.secs, _x.action_result.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_result.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_result.status.goal_id.stamp.secs, _x.action_result.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_result.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_result.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_result.status.text = str[start:end].decode('utf-8')
      else:
        self.action_result.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_result.result.grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v535 = val1.pre_grasp_posture
        _v536 = _v535.header
        start = end
        end += 4
        (_v536.seq,) = _struct_I.unpack(str[start:end])
        _v537 = _v536.stamp
        _x = _v537
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v536.frame_id = str[start:end].decode('utf-8')
        else:
          _v536.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v535.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v535.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v535.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v535.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v535.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v538 = val1.grasp_posture
        _v539 = _v538.header
        start = end
        end += 4
        (_v539.seq,) = _struct_I.unpack(str[start:end])
        _v540 = _v539.stamp
        _x = _v540
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v539.frame_id = str[start:end].decode('utf-8')
        else:
          _v539.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v538.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v538.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v538.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v538.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v538.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v541 = val1.grasp_pose
        _v542 = _v541.position
        _x = _v542
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v543 = _v541.orientation
        _x = _v543
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v544 = val3.pose
            _v545 = _v544.header
            start = end
            end += 4
            (_v545.seq,) = _struct_I.unpack(str[start:end])
            _v546 = _v545.stamp
            _x = _v546
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v545.frame_id = str[start:end].decode('utf-8')
            else:
              _v545.frame_id = str[start:end]
            _v547 = _v544.pose
            _v548 = _v547.position
            _x = _v548
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v549 = _v547.orientation
            _x = _v549
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v550 = val2.cluster
          _v551 = _v550.header
          start = end
          end += 4
          (_v551.seq,) = _struct_I.unpack(str[start:end])
          _v552 = _v551.stamp
          _x = _v552
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v551.frame_id = str[start:end].decode('utf-8')
          else:
            _v551.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v550.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v550.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v550.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
            _v550.channels.append(val4)
          _v553 = val2.region
          _v554 = _v553.cloud
          _v555 = _v554.header
          start = end
          end += 4
          (_v555.seq,) = _struct_I.unpack(str[start:end])
          _v556 = _v555.stamp
          _x = _v556
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v555.frame_id = str[start:end].decode('utf-8')
          else:
            _v555.frame_id = str[start:end]
          _x = _v554
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v554.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v554.fields.append(val5)
          _x = _v554
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v554.is_bigendian = bool(_v554.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v554.data = str[start:end].decode('utf-8')
          else:
            _v554.data = str[start:end]
          start = end
          end += 1
          (_v554.is_dense,) = _struct_B.unpack(str[start:end])
          _v554.is_dense = bool(_v554.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v553.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
          _v557 = _v553.image
          _v558 = _v557.header
          start = end
          end += 4
          (_v558.seq,) = _struct_I.unpack(str[start:end])
          _v559 = _v558.stamp
          _x = _v559
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v558.frame_id = str[start:end].decode('utf-8')
          else:
            _v558.frame_id = str[start:end]
          _x = _v557
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v557.encoding = str[start:end].decode('utf-8')
          else:
            _v557.encoding = str[start:end]
          _x = _v557
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v557.data = str[start:end].decode('utf-8')
          else:
            _v557.data = str[start:end]
          _v560 = _v553.disparity_image
          _v561 = _v560.header
          start = end
          end += 4
          (_v561.seq,) = _struct_I.unpack(str[start:end])
          _v562 = _v561.stamp
          _x = _v562
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v561.frame_id = str[start:end].decode('utf-8')
          else:
            _v561.frame_id = str[start:end]
          _x = _v560
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v560.encoding = str[start:end].decode('utf-8')
          else:
            _v560.encoding = str[start:end]
          _x = _v560
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v560.data = str[start:end].decode('utf-8')
          else:
            _v560.data = str[start:end]
          _v563 = _v553.cam_info
          _v564 = _v563.header
          start = end
          end += 4
          (_v564.seq,) = _struct_I.unpack(str[start:end])
          _v565 = _v564.stamp
          _x = _v565
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v564.frame_id = str[start:end].decode('utf-8')
          else:
            _v564.frame_id = str[start:end]
          _x = _v563
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v563.distortion_model = str[start:end].decode('utf-8')
          else:
            _v563.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v563.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 72
          _v563.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 72
          _v563.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 96
          _v563.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
          _x = _v563
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v566 = _v563.roi
          _x = _v566
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v566.do_rectify = bool(_v566.do_rectify)
          _v567 = _v553.roi_box_pose
          _v568 = _v567.header
          start = end
          end += 4
          (_v568.seq,) = _struct_I.unpack(str[start:end])
          _v569 = _v568.stamp
          _x = _v569
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v568.frame_id = str[start:end].decode('utf-8')
          else:
            _v568.frame_id = str[start:end]
          _v570 = _v567.pose
          _v571 = _v570.position
          _x = _v571
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v572 = _v570.orientation
          _x = _v572
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v573 = _v553.roi_box_dims
          _x = _v573
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_result.result.grasps.append(val1)
      _x = self
      start = end
      end += 16
      (_x.action_result.result.error_code.value, _x.action_feedback.header.seq, _x.action_feedback.header.stamp.secs, _x.action_feedback.header.stamp.nsecs,) = _struct_i3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.action_feedback.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.action_feedback.status.goal_id.stamp.secs, _x.action_feedback.status.goal_id.stamp.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.goal_id.id = str[start:end].decode('utf-8')
      else:
        self.action_feedback.status.goal_id.id = str[start:end]
      start = end
      end += 1
      (self.action_feedback.status.status,) = _struct_B.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_feedback.status.text = str[start:end].decode('utf-8')
      else:
        self.action_feedback.status.text = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.action_feedback.feedback.grasps = []
      for i in range(0, length):
        val1 = object_manipulation_msgs.msg.Grasp()
        _v574 = val1.pre_grasp_posture
        _v575 = _v574.header
        start = end
        end += 4
        (_v575.seq,) = _struct_I.unpack(str[start:end])
        _v576 = _v575.stamp
        _x = _v576
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v575.frame_id = str[start:end].decode('utf-8')
        else:
          _v575.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v574.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v574.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v574.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v574.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v574.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v577 = val1.grasp_posture
        _v578 = _v577.header
        start = end
        end += 4
        (_v578.seq,) = _struct_I.unpack(str[start:end])
        _v579 = _v578.stamp
        _x = _v579
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v578.frame_id = str[start:end].decode('utf-8')
        else:
          _v578.frame_id = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v577.name = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val3 = str[start:end].decode('utf-8')
          else:
            val3 = str[start:end]
          _v577.name.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v577.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v577.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v577.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v580 = val1.grasp_pose
        _v581 = _v580.position
        _x = _v581
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v582 = _v580.orientation
        _x = _v582
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        _x = val1
        start = end
        end += 17
        (_x.success_probability, _x.cluster_rep, _x.desired_approach_distance, _x.min_approach_distance,) = _struct_dB2f.unpack(str[start:end])
        val1.cluster_rep = bool(val1.cluster_rep)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.moved_obstacles = []
        for i in range(0, length):
          val2 = object_manipulation_msgs.msg.GraspableObject()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.reference_frame_id = str[start:end].decode('utf-8')
          else:
            val2.reference_frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.potential_models = []
          for i in range(0, length):
            val3 = household_objects_database_msgs.msg.DatabaseModelPose()
            start = end
            end += 4
            (val3.model_id,) = _struct_i.unpack(str[start:end])
            _v583 = val3.pose
            _v584 = _v583.header
            start = end
            end += 4
            (_v584.seq,) = _struct_I.unpack(str[start:end])
            _v585 = _v584.stamp
            _x = _v585
            start = end
            end += 8
            (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              _v584.frame_id = str[start:end].decode('utf-8')
            else:
              _v584.frame_id = str[start:end]
            _v586 = _v583.pose
            _v587 = _v586.position
            _x = _v587
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            _v588 = _v586.orientation
            _x = _v588
            start = end
            end += 32
            (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
            start = end
            end += 4
            (val3.confidence,) = _struct_f.unpack(str[start:end])
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val3.detector_name = str[start:end].decode('utf-8')
            else:
              val3.detector_name = str[start:end]
            val2.potential_models.append(val3)
          _v589 = val2.cluster
          _v590 = _v589.header
          start = end
          end += 4
          (_v590.seq,) = _struct_I.unpack(str[start:end])
          _v591 = _v590.stamp
          _x = _v591
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v590.frame_id = str[start:end].decode('utf-8')
          else:
            _v590.frame_id = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v589.points = []
          for i in range(0, length):
            val4 = geometry_msgs.msg.Point32()
            _x = val4
            start = end
            end += 12
            (_x.x, _x.y, _x.z,) = _struct_3f.unpack(str[start:end])
            _v589.points.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v589.channels = []
          for i in range(0, length):
            val4 = sensor_msgs.msg.ChannelFloat32()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val4.name = str[start:end].decode('utf-8')
            else:
              val4.name = str[start:end]
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sf'%length
            start = end
            end += struct.calcsize(pattern)
            val4.values = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
            _v589.channels.append(val4)
          _v592 = val2.region
          _v593 = _v592.cloud
          _v594 = _v593.header
          start = end
          end += 4
          (_v594.seq,) = _struct_I.unpack(str[start:end])
          _v595 = _v594.stamp
          _x = _v595
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v594.frame_id = str[start:end].decode('utf-8')
          else:
            _v594.frame_id = str[start:end]
          _x = _v593
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v593.fields = []
          for i in range(0, length):
            val5 = sensor_msgs.msg.PointField()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            start = end
            end += length
            if python3:
              val5.name = str[start:end].decode('utf-8')
            else:
              val5.name = str[start:end]
            _x = val5
            start = end
            end += 9
            (_x.offset, _x.datatype, _x.count,) = _struct_IBI.unpack(str[start:end])
            _v593.fields.append(val5)
          _x = _v593
          start = end
          end += 9
          (_x.is_bigendian, _x.point_step, _x.row_step,) = _struct_B2I.unpack(str[start:end])
          _v593.is_bigendian = bool(_v593.is_bigendian)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v593.data = str[start:end].decode('utf-8')
          else:
            _v593.data = str[start:end]
          start = end
          end += 1
          (_v593.is_dense,) = _struct_B.unpack(str[start:end])
          _v593.is_dense = bool(_v593.is_dense)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%si'%length
          start = end
          end += struct.calcsize(pattern)
          _v592.mask = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
          _v596 = _v592.image
          _v597 = _v596.header
          start = end
          end += 4
          (_v597.seq,) = _struct_I.unpack(str[start:end])
          _v598 = _v597.stamp
          _x = _v598
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v597.frame_id = str[start:end].decode('utf-8')
          else:
            _v597.frame_id = str[start:end]
          _x = _v596
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v596.encoding = str[start:end].decode('utf-8')
          else:
            _v596.encoding = str[start:end]
          _x = _v596
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v596.data = str[start:end].decode('utf-8')
          else:
            _v596.data = str[start:end]
          _v599 = _v592.disparity_image
          _v600 = _v599.header
          start = end
          end += 4
          (_v600.seq,) = _struct_I.unpack(str[start:end])
          _v601 = _v600.stamp
          _x = _v601
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v600.frame_id = str[start:end].decode('utf-8')
          else:
            _v600.frame_id = str[start:end]
          _x = _v599
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v599.encoding = str[start:end].decode('utf-8')
          else:
            _v599.encoding = str[start:end]
          _x = _v599
          start = end
          end += 5
          (_x.is_bigendian, _x.step,) = _struct_BI.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v599.data = str[start:end].decode('utf-8')
          else:
            _v599.data = str[start:end]
          _v602 = _v592.cam_info
          _v603 = _v602.header
          start = end
          end += 4
          (_v603.seq,) = _struct_I.unpack(str[start:end])
          _v604 = _v603.stamp
          _x = _v604
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v603.frame_id = str[start:end].decode('utf-8')
          else:
            _v603.frame_id = str[start:end]
          _x = _v602
          start = end
          end += 8
          (_x.height, _x.width,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v602.distortion_model = str[start:end].decode('utf-8')
          else:
            _v602.distortion_model = str[start:end]
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          _v602.D = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          start = end
          end += 72
          _v602.K = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 72
          _v602.R = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=9)
          start = end
          end += 96
          _v602.P = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=12)
          _x = _v602
          start = end
          end += 8
          (_x.binning_x, _x.binning_y,) = _struct_2I.unpack(str[start:end])
          _v605 = _v602.roi
          _x = _v605
          start = end
          end += 17
          (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = _struct_4IB.unpack(str[start:end])
          _v605.do_rectify = bool(_v605.do_rectify)
          _v606 = _v592.roi_box_pose
          _v607 = _v606.header
          start = end
          end += 4
          (_v607.seq,) = _struct_I.unpack(str[start:end])
          _v608 = _v607.stamp
          _x = _v608
          start = end
          end += 8
          (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            _v607.frame_id = str[start:end].decode('utf-8')
          else:
            _v607.frame_id = str[start:end]
          _v609 = _v606.pose
          _v610 = _v609.position
          _x = _v610
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          _v611 = _v609.orientation
          _x = _v611
          start = end
          end += 32
          (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
          _v612 = _v592.roi_box_dims
          _x = _v612
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2.collision_name = str[start:end].decode('utf-8')
          else:
            val2.collision_name = str[start:end]
          val1.moved_obstacles.append(val2)
        self.action_feedback.feedback.grasps.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_IBI = struct.Struct("<IBI")
_struct_6IB3I = struct.Struct("<6IB3I")
_struct_B = struct.Struct("<B")
_struct_12d = struct.Struct("<12d")
_struct_f = struct.Struct("<f")
_struct_i = struct.Struct("<i")
_struct_dB2f = struct.Struct("<dB2f")
_struct_BI = struct.Struct("<BI")
_struct_10d = struct.Struct("<10d")
_struct_3f = struct.Struct("<3f")
_struct_3I = struct.Struct("<3I")
_struct_9d = struct.Struct("<9d")
_struct_B2I = struct.Struct("<B2I")
_struct_i3I = struct.Struct("<i3I")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_4IB = struct.Struct("<4IB")
_struct_3d = struct.Struct("<3d")
